package de.upb.inferenceengine.engines;

import de.upb.tools.fca.FEmptyIterator;
import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.upb.javaast.methodast.IdentifierNode;
import java.util.regex.Pattern;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.ASTRootNode;
import de.upb.javaast.methodast.PrimaryExpressionNode;
import de.upb.javaast.methodast.MethodCallNode;
import de.upb.javaast.methodast.ReturnNode;

public class ContainerReadOperationEngine
extends GFRNEngine
{
   private  ContainerReadOperationEngine()
   {
   }

   private static ContainerReadOperationEngine theContainerReadOperationEngine;

   public static ContainerReadOperationEngine get()
   {
      if (theContainerReadOperationEngine == null)
      {
         theContainerReadOperationEngine = new ContainerReadOperationEngine ();
      }
      return theContainerReadOperationEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ASTPathVisitor fujaba__IterReturnNode3ToPrimaryExpressionNode4 = null ;
      ASTPathVisitor fujaba__IterReturnNode8ToPrimaryExpressionNode9 = null ;
      ASTPathVisitor fujaba__IterRootToReturnNode3 = null ;
      ASTPathVisitor fujaba__IterRootToReturnNode8 = null ;
      de.uni_paderborn.fujaba.uml.ASTRootNode root = null ;
      ContainerReadOperationAnnotation containerReadOperation = null ;
      Iterator fujaba__IterAttribAnnotationsContainerReadOperation = null ;
      Iterator fujaba__IterReadMethodAnnotationsContainerReadOperation = null ;
      Iterator fujaba__IterUMLClass2AttrsAttrib = null ;
      Iterator fujaba__IterUMLClass7MethodsReadMethod = null ;
      de.upb.javaast.methodast.IdentifierNode id = null ;
      de.upb.javaast.methodast.IdentifierNode identifierNode1 = null ;
      de.upb.javaast.methodast.IdentifierNode identifierNode6 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode10 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode5 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode4 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode9 = null ;
      de.upb.javaast.methodast.ReturnNode returnNode3 = null ;
      de.upb.javaast.methodast.ReturnNode returnNode8 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr attrib = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass2 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass7 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod readMethod = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            readMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind root: ASTRootNode
            root = readMethod.getASTRootNode () ;
            JavaSDM.ensure ( root != null ) ;
             
            // bind uMLClass2: UMLClass
            uMLClass2 = readMethod.getParent () ;
            JavaSDM.ensure ( uMLClass2 != null ) ;
             
            // bind attrib: UMLAttr
            fujaba__IterUMLClass2AttrsAttrib = uMLClass2.iteratorOfAttrs () ;
            while ( fujaba__IterUMLClass2AttrsAttrib.hasNext () )
            {
               try
               {
                  attrib = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterUMLClass2AttrsAttrib.next () ;
                   
                  // Path search between ASTRootNode and ReturnNode
                  // Bind returnNode3 : ReturnNode
                  fujaba__IterRootToReturnNode3 = new ASTPathVisitor (root, ReturnNode.class ) ;
                  while ( fujaba__IterRootToReturnNode3.hasNext () )
                  {
                     try
                     {
                        returnNode3 = (de.upb.javaast.methodast.ReturnNode) fujaba__IterRootToReturnNode3.next () ;
                         
                        // Path search between ReturnNode and PrimaryExpressionNode
                        // Bind primaryExpressionNode4 : PrimaryExpressionNode
                        fujaba__IterReturnNode3ToPrimaryExpressionNode4 = new ASTPathVisitor (returnNode3, PrimaryExpressionNode.class ) ;
                        while ( fujaba__IterReturnNode3ToPrimaryExpressionNode4.hasNext () )
                        {
                           try
                           {
                              primaryExpressionNode4 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterReturnNode3ToPrimaryExpressionNode4.next () ;
                               
                              // bind methodCallNode5: MethodCallNode
                              fujaba__TmpObject = primaryExpressionNode4.getNextPrimaryExpression () ;
                              JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                              methodCallNode5 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(primaryExpressionNode4.equals (methodCallNode5)) ) ;
                               
                              // bind id: IdentifierNode
                              id = primaryExpressionNode4.getIdentifier () ;
                              JavaSDM.ensure ( id != null ) ;
                               
                              // bind identifierNode1: IdentifierNode
                              identifierNode1 = methodCallNode5.getIdentifier () ;
                              JavaSDM.ensure ( identifierNode1 != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( ((identifierNode1.getName () != null) && Pattern.matches (".*iterator.*", identifierNode1.getName ())) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(id.equals (identifierNode1)) ) ;
                               
                              // constraint
                              JavaSDM.ensure ( id.getName().equals(attrib.getName()) ) ;
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object readMethod is really bound
                                    JavaSDM.ensure ( readMethod != null ) ;
                                     
                                    // check object attrib is really bound
                                    JavaSDM.ensure ( attrib != null ) ;
                                     
                                    // bind containerReadOperation: ContainerReadOperationAnnotation
                                    fujaba__IterAttribAnnotationsContainerReadOperation = attrib.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterAttribAnnotationsContainerReadOperation.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAttribAnnotationsContainerReadOperation.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerReadOperationAnnotation ) ;
                                          containerReadOperation = (ContainerReadOperationAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between containerReadOperation and attrib
                                          JavaSDM.ensure ( containerReadOperation.hasInElements ("field", attrib) ) ;
                                           
                                          // check To-Many-Link 'elements' between containerReadOperation and readMethod
                                          JavaSDM.ensure ( containerReadOperation.hasInElements ("method", readMethod) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object readMethod is really bound
                                       JavaSDM.ensure ( readMethod != null ) ;
                                        
                                       // check object attrib is really bound
                                       JavaSDM.ensure ( attrib != null ) ;
                                        
                                       // check object root is really bound
                                       JavaSDM.ensure ( root != null ) ;
                                        
                                       // check object id is really bound
                                       JavaSDM.ensure ( id != null ) ;
                                        
                                       // create object
                                       containerReadOperation = new ContainerReadOperationAnnotation ( ) ;
                                        
                                       // create link
                                       containerReadOperation.addToElements ("method", readMethod);
                                        
                                       // create link
                                       containerReadOperation.addToElements ("field", attrib);
                                        
                                       // create link
                                       containerReadOperation.addToBoundObjects ("readMethod", readMethod);
                                        
                                       // create link
                                       containerReadOperation.addToBoundObjects ("attrib", attrib);
                                        
                                       // create link
                                       containerReadOperation.addToBoundObjects ("root", root);
                                        
                                       // create link
                                       containerReadOperation.addToBoundObjects ("id", id);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (containerReadOperation) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object containerReadOperation is really bound
            JavaSDM.ensure ( containerReadOperation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("method", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            attrib = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind uMLClass7: UMLClass
            uMLClass7 = attrib.getParent () ;
            JavaSDM.ensure ( uMLClass7 != null ) ;
             
            // bind readMethod: UMLMethod
            fujaba__IterUMLClass7MethodsReadMethod = uMLClass7.iteratorOfMethods () ;
            while ( fujaba__IterUMLClass7MethodsReadMethod.hasNext () )
            {
               try
               {
                  readMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterUMLClass7MethodsReadMethod.next () ;
                   
                  // bind root: ASTRootNode
                  root = readMethod.getASTRootNode () ;
                  JavaSDM.ensure ( root != null ) ;
                   
                  // Path search between ASTRootNode and ReturnNode
                  // Bind returnNode8 : ReturnNode
                  fujaba__IterRootToReturnNode8 = new ASTPathVisitor (root, ReturnNode.class ) ;
                  while ( fujaba__IterRootToReturnNode8.hasNext () )
                  {
                     try
                     {
                        returnNode8 = (de.upb.javaast.methodast.ReturnNode) fujaba__IterRootToReturnNode8.next () ;
                         
                        // Path search between ReturnNode and PrimaryExpressionNode
                        // Bind primaryExpressionNode9 : PrimaryExpressionNode
                        fujaba__IterReturnNode8ToPrimaryExpressionNode9 = new ASTPathVisitor (returnNode8, PrimaryExpressionNode.class ) ;
                        while ( fujaba__IterReturnNode8ToPrimaryExpressionNode9.hasNext () )
                        {
                           try
                           {
                              primaryExpressionNode9 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterReturnNode8ToPrimaryExpressionNode9.next () ;
                               
                              // bind methodCallNode10: MethodCallNode
                              fujaba__TmpObject = primaryExpressionNode9.getNextPrimaryExpression () ;
                              JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                              methodCallNode10 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(primaryExpressionNode9.equals (methodCallNode10)) ) ;
                               
                              // bind id: IdentifierNode
                              id = primaryExpressionNode9.getIdentifier () ;
                              JavaSDM.ensure ( id != null ) ;
                               
                              // bind identifierNode6: IdentifierNode
                              identifierNode6 = methodCallNode10.getIdentifier () ;
                              JavaSDM.ensure ( identifierNode6 != null ) ;
                               
                              // attribute condition
                              JavaSDM.ensure ( ((identifierNode6.getName () != null) && Pattern.matches (".*iterator.*", identifierNode6.getName ())) ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(id.equals (identifierNode6)) ) ;
                               
                              // constraint
                              JavaSDM.ensure ( id.getName().equals(attrib.getName()) ) ;
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object readMethod is really bound
                                    JavaSDM.ensure ( readMethod != null ) ;
                                     
                                    // check object attrib is really bound
                                    JavaSDM.ensure ( attrib != null ) ;
                                     
                                    // bind containerReadOperation: ContainerReadOperationAnnotation
                                    fujaba__IterReadMethodAnnotationsContainerReadOperation = readMethod.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterReadMethodAnnotationsContainerReadOperation.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterReadMethodAnnotationsContainerReadOperation.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerReadOperationAnnotation ) ;
                                          containerReadOperation = (ContainerReadOperationAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between containerReadOperation and readMethod
                                          JavaSDM.ensure ( containerReadOperation.hasInElements ("method", readMethod) ) ;
                                           
                                          // check To-Many-Link 'elements' between containerReadOperation and attrib
                                          JavaSDM.ensure ( containerReadOperation.hasInElements ("field", attrib) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object readMethod is really bound
                                       JavaSDM.ensure ( readMethod != null ) ;
                                        
                                       // check object attrib is really bound
                                       JavaSDM.ensure ( attrib != null ) ;
                                        
                                       // check object root is really bound
                                       JavaSDM.ensure ( root != null ) ;
                                        
                                       // check object id is really bound
                                       JavaSDM.ensure ( id != null ) ;
                                        
                                       // create object
                                       containerReadOperation = new ContainerReadOperationAnnotation ( ) ;
                                        
                                       // create link
                                       containerReadOperation.addToElements ("method", readMethod);
                                        
                                       // create link
                                       containerReadOperation.addToElements ("field", attrib);
                                        
                                       // create link
                                       containerReadOperation.addToBoundObjects ("readMethod", readMethod);
                                        
                                       // create link
                                       containerReadOperation.addToBoundObjects ("attrib", attrib);
                                        
                                       // create link
                                       containerReadOperation.addToBoundObjects ("root", root);
                                        
                                       // create link
                                       containerReadOperation.addToBoundObjects ("id", id);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (containerReadOperation) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object containerReadOperation is really bound
            JavaSDM.ensure ( containerReadOperation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (containerReadOperation) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      return (FEmptyIterator.get()) ;
   }


}
