package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLMethod;

public class FlyweightEngine
extends GFRNEngine
{
   private  FlyweightEngine()
   {
   }

   private static FlyweightEngine theFlyweightEngine;

   public static FlyweightEngine get()
   {
      if (theFlyweightEngine == null)
      {
         theFlyweightEngine = new FlyweightEngine ();
      }
      return theFlyweightEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      CreateMethodAnnotation createMethod14 = null ;
      CreateMethodAnnotation createMethod4 = null ;
      CreateMethodAnnotation createMethod9 = null ;
      Iterator fujaba__IterCreateMethod14ElementsUMLMethod15 = null ;
      Iterator fujaba__IterOneToManyAssociation11ElementsUMLClass12 = null ;
      Iterator fujaba__IterOneToManyAssociation1ElementsUMLClass2 = null ;
      Iterator fujaba__IterOneToManyAssociation1ElementsUMLClass3 = null ;
      Iterator fujaba__IterOneToManyAssociation6ElementsUMLClass8 = null ;
      Iterator fujaba__IterUMLClass12AnnotationsFlyweight = null ;
      Iterator fujaba__IterUMLClass13AnnotationsCreateMethod14 = null ;
      Iterator fujaba__IterUMLClass13AnnotationsOneToManyAssociation11 = null ;
      Iterator fujaba__IterUMLClass2AnnotationsFlyweight = null ;
      Iterator fujaba__IterUMLClass2MethodsUMLMethod5 = null ;
      Iterator fujaba__IterUMLClass3AnnotationsCreateMethod4 = null ;
      Iterator fujaba__IterUMLClass7AnnotationsOneToManyAssociation6 = null ;
      Iterator fujaba__IterUMLClass7MethodsUMLMethod10 = null ;
      Iterator fujaba__IterUMLClass8AnnotationsFlyweight = null ;
      Iterator fujaba__IterUMLMethod10AnnotationsCreateMethod9 = null ;
      FlyweightAnnotation flyweight = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation1 = null ;
      OneToManyAssociationAnnotation oneToManyAssociation11 = null ;
      OneToManyAssociationAnnotation oneToManyAssociation6 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass12 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass13 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass2 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass3 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass7 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass8 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod10 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod15 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod5 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OneToManyAssociationAnnotation ) ;
             
            // explicit type cast
            oneToManyAssociation1 = (OneToManyAssociationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLClass2: UMLClass
            fujaba__IterOneToManyAssociation1ElementsUMLClass2 = oneToManyAssociation1.iteratorOfElements ("one") ;
            while ( fujaba__IterOneToManyAssociation1ElementsUMLClass2.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOneToManyAssociation1ElementsUMLClass2.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  uMLClass2 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLClass3: UMLClass
                  fujaba__IterOneToManyAssociation1ElementsUMLClass3 = oneToManyAssociation1.iteratorOfElements ("many") ;
                  while ( fujaba__IterOneToManyAssociation1ElementsUMLClass3.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterOneToManyAssociation1ElementsUMLClass3.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        uMLClass3 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(uMLClass2.equals (uMLClass3)) ) ;
                         
                        // bind uMLMethod5: UMLMethod
                        fujaba__IterUMLClass2MethodsUMLMethod5 = uMLClass2.iteratorOfMethods () ;
                        while ( fujaba__IterUMLClass2MethodsUMLMethod5.hasNext () )
                        {
                           try
                           {
                              uMLMethod5 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterUMLClass2MethodsUMLMethod5.next () ;
                               
                              // bind createMethod4: CreateMethodAnnotation
                              fujaba__IterUMLClass3AnnotationsCreateMethod4 = uMLClass3.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLClass3AnnotationsCreateMethod4.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLClass3AnnotationsCreateMethod4.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                                    createMethod4 = (CreateMethodAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between createMethod4 and uMLClass3
                                    JavaSDM.ensure ( createMethod4.hasInElements ("creates", uMLClass3) ) ;
                                     
                                    // check To-Many-Link 'elements' between createMethod4 and uMLMethod5
                                    JavaSDM.ensure ( createMethod4.hasInElements ("method", uMLMethod5) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object uMLClass2 is really bound
                                          JavaSDM.ensure ( uMLClass2 != null ) ;
                                           
                                          // check object uMLClass3 is really bound
                                          JavaSDM.ensure ( uMLClass3 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLClass2.equals (uMLClass3)) ) ;
                                           
                                          // bind flyweight: FlyweightAnnotation
                                          fujaba__IterUMLClass2AnnotationsFlyweight = uMLClass2.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterUMLClass2AnnotationsFlyweight.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLClass2AnnotationsFlyweight.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof FlyweightAnnotation ) ;
                                                flyweight = (FlyweightAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between flyweight and uMLClass2
                                                JavaSDM.ensure ( flyweight.hasInElements ("factory", uMLClass2) ) ;
                                                 
                                                // check To-Many-Link 'elements' between flyweight and uMLClass3
                                                JavaSDM.ensure ( flyweight.hasInElements ("flyweight", uMLClass3) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object uMLClass2 is really bound
                                             JavaSDM.ensure ( uMLClass2 != null ) ;
                                              
                                             // check object uMLClass3 is really bound
                                             JavaSDM.ensure ( uMLClass3 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(uMLClass2.equals (uMLClass3)) ) ;
                                              
                                             // create object
                                             flyweight = new FlyweightAnnotation ( ) ;
                                              
                                             // create link
                                             flyweight.addToElements ("factory", uMLClass2);
                                              
                                             // create link
                                             flyweight.addToElements ("flyweight", uMLClass3);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object oneToManyAssociation1 is really bound
                                             JavaSDM.ensure ( oneToManyAssociation1 != null ) ;
                                              
                                             // check object createMethod4 is really bound
                                             JavaSDM.ensure ( createMethod4 != null ) ;
                                              
                                             // check object flyweight is really bound
                                             JavaSDM.ensure ( flyweight != null ) ;
                                              
                                             // create link
                                             flyweight.addToAntecedentAnnos (oneToManyAssociation1);
                                              
                                             // create link
                                             flyweight.addToAntecedentAnnos (createMethod4);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (flyweight) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object flyweight is really bound
            JavaSDM.ensure ( flyweight != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("factory", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass7 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod10: UMLMethod
            fujaba__IterUMLClass7MethodsUMLMethod10 = uMLClass7.iteratorOfMethods () ;
            while ( fujaba__IterUMLClass7MethodsUMLMethod10.hasNext () )
            {
               try
               {
                  uMLMethod10 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterUMLClass7MethodsUMLMethod10.next () ;
                   
                  // bind oneToManyAssociation6: OneToManyAssociationAnnotation
                  fujaba__IterUMLClass7AnnotationsOneToManyAssociation6 = uMLClass7.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLClass7AnnotationsOneToManyAssociation6.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLClass7AnnotationsOneToManyAssociation6.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                        oneToManyAssociation6 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between oneToManyAssociation6 and uMLClass7
                        JavaSDM.ensure ( oneToManyAssociation6.hasInElements ("one", uMLClass7) ) ;
                         
                        // bind createMethod9: CreateMethodAnnotation
                        fujaba__IterUMLMethod10AnnotationsCreateMethod9 = uMLMethod10.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLMethod10AnnotationsCreateMethod9.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterUMLMethod10AnnotationsCreateMethod9.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                              createMethod9 = (CreateMethodAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between createMethod9 and uMLMethod10
                              JavaSDM.ensure ( createMethod9.hasInElements ("method", uMLMethod10) ) ;
                               
                              // bind uMLClass8: UMLClass
                              fujaba__IterOneToManyAssociation6ElementsUMLClass8 = oneToManyAssociation6.iteratorOfElements ("many") ;
                              while ( fujaba__IterOneToManyAssociation6ElementsUMLClass8.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterOneToManyAssociation6ElementsUMLClass8.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    uMLClass8 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(uMLClass7.equals (uMLClass8)) ) ;
                                     
                                    // check To-Many-Link 'elements' between createMethod9 and uMLClass8
                                    JavaSDM.ensure ( createMethod9.hasInElements ("creates", uMLClass8) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object uMLClass7 is really bound
                                          JavaSDM.ensure ( uMLClass7 != null ) ;
                                           
                                          // check object uMLClass8 is really bound
                                          JavaSDM.ensure ( uMLClass8 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLClass7.equals (uMLClass8)) ) ;
                                           
                                          // bind flyweight: FlyweightAnnotation
                                          fujaba__IterUMLClass8AnnotationsFlyweight = uMLClass8.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterUMLClass8AnnotationsFlyweight.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLClass8AnnotationsFlyweight.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof FlyweightAnnotation ) ;
                                                flyweight = (FlyweightAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between flyweight and uMLClass8
                                                JavaSDM.ensure ( flyweight.hasInElements ("flyweight", uMLClass8) ) ;
                                                 
                                                // check To-Many-Link 'elements' between flyweight and uMLClass7
                                                JavaSDM.ensure ( flyweight.hasInElements ("factory", uMLClass7) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object uMLClass7 is really bound
                                             JavaSDM.ensure ( uMLClass7 != null ) ;
                                              
                                             // check object uMLClass8 is really bound
                                             JavaSDM.ensure ( uMLClass8 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(uMLClass7.equals (uMLClass8)) ) ;
                                              
                                             // create object
                                             flyweight = new FlyweightAnnotation ( ) ;
                                              
                                             // create link
                                             flyweight.addToElements ("factory", uMLClass7);
                                              
                                             // create link
                                             flyweight.addToElements ("flyweight", uMLClass8);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object oneToManyAssociation6 is really bound
                                             JavaSDM.ensure ( oneToManyAssociation6 != null ) ;
                                              
                                             // check object createMethod9 is really bound
                                             JavaSDM.ensure ( createMethod9 != null ) ;
                                              
                                             // check object flyweight is really bound
                                             JavaSDM.ensure ( flyweight != null ) ;
                                              
                                             // create link
                                             flyweight.addToAntecedentAnnos (oneToManyAssociation6);
                                              
                                             // create link
                                             flyweight.addToAntecedentAnnos (createMethod9);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (flyweight) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object flyweight is really bound
            JavaSDM.ensure ( flyweight != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("factory", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("flyweight", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass13 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind oneToManyAssociation11: OneToManyAssociationAnnotation
            fujaba__IterUMLClass13AnnotationsOneToManyAssociation11 = uMLClass13.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLClass13AnnotationsOneToManyAssociation11.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLClass13AnnotationsOneToManyAssociation11.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof OneToManyAssociationAnnotation ) ;
                  oneToManyAssociation11 = (OneToManyAssociationAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between oneToManyAssociation11 and uMLClass13
                  JavaSDM.ensure ( oneToManyAssociation11.hasInElements ("many", uMLClass13) ) ;
                   
                  // bind createMethod14: CreateMethodAnnotation
                  fujaba__IterUMLClass13AnnotationsCreateMethod14 = uMLClass13.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLClass13AnnotationsCreateMethod14.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLClass13AnnotationsCreateMethod14.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof CreateMethodAnnotation ) ;
                        createMethod14 = (CreateMethodAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between createMethod14 and uMLClass13
                        JavaSDM.ensure ( createMethod14.hasInElements ("creates", uMLClass13) ) ;
                         
                        // bind uMLClass12: UMLClass
                        fujaba__IterOneToManyAssociation11ElementsUMLClass12 = oneToManyAssociation11.iteratorOfElements ("one") ;
                        while ( fujaba__IterOneToManyAssociation11ElementsUMLClass12.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterOneToManyAssociation11ElementsUMLClass12.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              uMLClass12 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(uMLClass13.equals (uMLClass12)) ) ;
                               
                              // bind uMLMethod15: UMLMethod
                              fujaba__IterCreateMethod14ElementsUMLMethod15 = createMethod14.iteratorOfElements ("method") ;
                              while ( fujaba__IterCreateMethod14ElementsUMLMethod15.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterCreateMethod14ElementsUMLMethod15.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
                                    uMLMethod15 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__TmpObject ;
                                     
                                    // check To-One-Link 'parent' between uMLMethod15 and uMLClass12
                                    JavaSDM.ensure ( (uMLMethod15.getParent () != null) && uMLMethod15.getParent ().equals (uMLClass12) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object uMLClass12 is really bound
                                          JavaSDM.ensure ( uMLClass12 != null ) ;
                                           
                                          // check object uMLClass13 is really bound
                                          JavaSDM.ensure ( uMLClass13 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(uMLClass12.equals (uMLClass13)) ) ;
                                           
                                          // bind flyweight: FlyweightAnnotation
                                          fujaba__IterUMLClass12AnnotationsFlyweight = uMLClass12.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterUMLClass12AnnotationsFlyweight.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterUMLClass12AnnotationsFlyweight.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof FlyweightAnnotation ) ;
                                                flyweight = (FlyweightAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between flyweight and uMLClass12
                                                JavaSDM.ensure ( flyweight.hasInElements ("factory", uMLClass12) ) ;
                                                 
                                                // check To-Many-Link 'elements' between flyweight and uMLClass13
                                                JavaSDM.ensure ( flyweight.hasInElements ("flyweight", uMLClass13) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object uMLClass12 is really bound
                                             JavaSDM.ensure ( uMLClass12 != null ) ;
                                              
                                             // check object uMLClass13 is really bound
                                             JavaSDM.ensure ( uMLClass13 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(uMLClass12.equals (uMLClass13)) ) ;
                                              
                                             // create object
                                             flyweight = new FlyweightAnnotation ( ) ;
                                              
                                             // create link
                                             flyweight.addToElements ("factory", uMLClass12);
                                              
                                             // create link
                                             flyweight.addToElements ("flyweight", uMLClass13);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object oneToManyAssociation11 is really bound
                                             JavaSDM.ensure ( oneToManyAssociation11 != null ) ;
                                              
                                             // check object createMethod14 is really bound
                                             JavaSDM.ensure ( createMethod14 != null ) ;
                                              
                                             // check object flyweight is really bound
                                             JavaSDM.ensure ( flyweight != null ) ;
                                              
                                             // create link
                                             flyweight.addToAntecedentAnnos (oneToManyAssociation11);
                                              
                                             // create link
                                             flyweight.addToAntecedentAnnos (createMethod14);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (flyweight) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object flyweight is really bound
            JavaSDM.ensure ( flyweight != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("flyweight", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (flyweight) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("factory", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("flyweight", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof OneToManyAssociationAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof CreateMethodAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      Iterator fujaba__IterOneToManyAssociation11ElementsUMLClass17 = null ;
      Iterator fujaba__IterUMLClass12MethodsUMLMethod16 = null ;
      Iterator fujaba__IterUMLClass17MethodsUMLMethod18 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      OneToManyAssociationAnnotation oneToManyAssociation11 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass12 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass13 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass17 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod16 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod uMLMethod18 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("OneToManyAssociation") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass12 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLClass12);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass13 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLClass13);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("CreateMethod") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass12 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLMethod16: UMLMethod
            fujaba__IterUMLClass12MethodsUMLMethod16 = uMLClass12.iteratorOfMethods () ;
            while ( fujaba__IterUMLClass12MethodsUMLMethod16.hasNext () )
            {
               try
               {
                  uMLMethod16 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterUMLClass12MethodsUMLMethod16.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLMethod16);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass13 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLClass13);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof OneToManyAssociationAnnotation ) ;
             
            // explicit type cast
            oneToManyAssociation11 = (OneToManyAssociationAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLClass17: UMLClass
            fujaba__IterOneToManyAssociation11ElementsUMLClass17 = oneToManyAssociation11.iteratorOfElements ("one") ;
            while ( fujaba__IterOneToManyAssociation11ElementsUMLClass17.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterOneToManyAssociation11ElementsUMLClass17.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                  uMLClass17 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                   
                  // bind uMLMethod18: UMLMethod
                  fujaba__IterUMLClass17MethodsUMLMethod18 = uMLClass17.iteratorOfMethods () ;
                  while ( fujaba__IterUMLClass17MethodsUMLMethod18.hasNext () )
                  {
                     try
                     {
                        uMLMethod18 = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterUMLClass17MethodsUMLMethod18.next () ;
                         
                        {
                           //  for each flow
                           set.add (uMLMethod18);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
