package de.upb.inferenceengine.engines;

import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLParam;

public class MultiReferenceEngine
extends GFRNEngine
{
   private  MultiReferenceEngine()
   {
   }

   private static MultiReferenceEngine theMultiReferenceEngine;

   public static MultiReferenceEngine get()
   {
      if (theMultiReferenceEngine == null)
      {
         theMultiReferenceEngine = new MultiReferenceEngine ();
      }
      return theMultiReferenceEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess13 = null ;
      ContainerAccessAnnotation containerAccess3 = null ;
      ContainerAccessAnnotation containerAccess8 = null ;
      Iterator fujaba__IterContainerAccess13ElementsUMLAttr11 = null ;
      Iterator fujaba__IterContainerAccess3ElementsUMLParam5 = null ;
      Iterator fujaba__IterContainerAccess8ElementsUMLAttr6 = null ;
      Iterator fujaba__IterContainerAccess8ElementsUMLParam10 = null ;
      Iterator fujaba__IterUMLAttr11AnnotationsQualifiedReference12 = null ;
      Iterator fujaba__IterUMLAttr1AnnotationsContainerAccess3 = null ;
      Iterator fujaba__IterUMLAttr1AnnotationsQualifiedReference2 = null ;
      Iterator fujaba__IterUMLAttr6AnnotationsMultiReference = null ;
      Iterator fujaba__IterUMLAttr6AnnotationsQualifiedReference7 = null ;
      Iterator fujaba__IterUMLClass14AnnotationsMultiReference = null ;
      Iterator fujaba__IterUMLClass14RevParamTypeUMLParam15 = null ;
      Iterator fujaba__IterUMLClass4AnnotationsMultiReference = null ;
      Iterator fujaba__IterUMLParam15AnnotationsContainerAccess13 = null ;
      MultiReferenceAnnotation multiReference = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      QualifiedReferenceAnnotation qualifiedReference12 = null ;
      QualifiedReferenceAnnotation qualifiedReference2 = null ;
      QualifiedReferenceAnnotation qualifiedReference7 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr1 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr11 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr6 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass14 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass4 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass9 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam10 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam15 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam5 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr1 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind containerAccess3: ContainerAccessAnnotation
            fujaba__IterUMLAttr1AnnotationsContainerAccess3 = uMLAttr1.iteratorOfAnnotations () ;
            while ( fujaba__IterUMLAttr1AnnotationsContainerAccess3.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterUMLAttr1AnnotationsContainerAccess3.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                  containerAccess3 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between containerAccess3 and uMLAttr1
                  JavaSDM.ensure ( containerAccess3.hasInElements ("field", uMLAttr1) ) ;
                   
                  // bind uMLParam5: UMLParam
                  fujaba__IterContainerAccess3ElementsUMLParam5 = containerAccess3.iteratorOfElements ("param") ;
                  while ( fujaba__IterContainerAccess3ElementsUMLParam5.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterContainerAccess3ElementsUMLParam5.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                        uMLParam5 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__TmpObject ;
                         
                        // bind uMLClass4: UMLClass
                        fujaba__TmpObject = uMLParam5.getParamType () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        uMLClass4 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check To-Many-Link 'annotations' between uMLAttr1 and qualifiedReference2
                        fujaba__IterUMLAttr1AnnotationsQualifiedReference2 = uMLAttr1.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLAttr1AnnotationsQualifiedReference2.hasNext () )
                        {
                           fujaba__TmpObject = fujaba__IterUMLAttr1AnnotationsQualifiedReference2.next () ;
                            
                           if ( fujaba__TmpObject instanceof QualifiedReferenceAnnotation )
                           {
                              qualifiedReference2 = (QualifiedReferenceAnnotation) fujaba__TmpObject ;
                               
                              JavaSDM.ensure ( !(qualifiedReference2.hasInElements ("field", uMLAttr1)) ) ;
                           }
                        } // while
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object uMLAttr1 is really bound
                              JavaSDM.ensure ( uMLAttr1 != null ) ;
                               
                              // check object uMLClass4 is really bound
                              JavaSDM.ensure ( uMLClass4 != null ) ;
                               
                              // bind multiReference: MultiReferenceAnnotation
                              fujaba__IterUMLClass4AnnotationsMultiReference = uMLClass4.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterUMLClass4AnnotationsMultiReference.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLClass4AnnotationsMultiReference.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                    multiReference = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between multiReference and uMLClass4
                                    JavaSDM.ensure ( multiReference.hasInElements ("references", uMLClass4) ) ;
                                     
                                    // check To-Many-Link 'elements' between multiReference and uMLAttr1
                                    JavaSDM.ensure ( multiReference.hasInElements ("field", uMLAttr1) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object uMLAttr1 is really bound
                                 JavaSDM.ensure ( uMLAttr1 != null ) ;
                                  
                                 // check object uMLClass4 is really bound
                                 JavaSDM.ensure ( uMLClass4 != null ) ;
                                  
                                 // create object
                                 multiReference = new MultiReferenceAnnotation ( ) ;
                                  
                                 // create link
                                 multiReference.addToElements ("field", uMLAttr1);
                                  
                                 // create link
                                 multiReference.addToElements ("references", uMLClass4);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object containerAccess3 is really bound
                                 JavaSDM.ensure ( containerAccess3 != null ) ;
                                  
                                 // check object multiReference is really bound
                                 JavaSDM.ensure ( multiReference != null ) ;
                                  
                                 // create link
                                 multiReference.addToAntecedentAnnos (containerAccess3);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (multiReference) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiReference is really bound
            JavaSDM.ensure ( multiReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ContainerAccessAnnotation ) ;
             
            // explicit type cast
            containerAccess8 = (ContainerAccessAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr6: UMLAttr
            fujaba__IterContainerAccess8ElementsUMLAttr6 = containerAccess8.iteratorOfElements ("field") ;
            while ( fujaba__IterContainerAccess8ElementsUMLAttr6.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterContainerAccess8ElementsUMLAttr6.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  uMLAttr6 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                   
                  // bind uMLParam10: UMLParam
                  fujaba__IterContainerAccess8ElementsUMLParam10 = containerAccess8.iteratorOfElements ("param") ;
                  while ( fujaba__IterContainerAccess8ElementsUMLParam10.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterContainerAccess8ElementsUMLParam10.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLParam ) ;
                        uMLParam10 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__TmpObject ;
                         
                        // bind uMLClass9: UMLClass
                        fujaba__TmpObject = uMLParam10.getParamType () ;
                        JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        uMLClass9 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check To-Many-Link 'annotations' between uMLAttr6 and qualifiedReference7
                        fujaba__IterUMLAttr6AnnotationsQualifiedReference7 = uMLAttr6.iteratorOfAnnotations () ;
                        while ( fujaba__IterUMLAttr6AnnotationsQualifiedReference7.hasNext () )
                        {
                           fujaba__TmpObject = fujaba__IterUMLAttr6AnnotationsQualifiedReference7.next () ;
                            
                           if ( fujaba__TmpObject instanceof QualifiedReferenceAnnotation )
                           {
                              qualifiedReference7 = (QualifiedReferenceAnnotation) fujaba__TmpObject ;
                               
                              JavaSDM.ensure ( !(qualifiedReference7.hasInElements ("field", uMLAttr6)) ) ;
                           }
                        } // while
                         
                        {
                           //  for each flow
                           try
                           {
                              fujaba__Success = false ;
                               
                              // check object uMLAttr6 is really bound
                              JavaSDM.ensure ( uMLAttr6 != null ) ;
                               
                              // check object uMLClass9 is really bound
                              JavaSDM.ensure ( uMLClass9 != null ) ;
                               
                              // bind multiReference: MultiReferenceAnnotation
                              fujaba__IterUMLAttr6AnnotationsMultiReference = uMLAttr6.iteratorOfAnnotations () ;
                              while ( !(fujaba__Success) && fujaba__IterUMLAttr6AnnotationsMultiReference.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterUMLAttr6AnnotationsMultiReference.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                    multiReference = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    // check Reverse-Qualified-Link 'elements' between multiReference and uMLAttr6
                                    JavaSDM.ensure ( multiReference.hasInElements ("field", uMLAttr6) ) ;
                                     
                                    // check To-Many-Link 'elements' between multiReference and uMLClass9
                                    JavaSDM.ensure ( multiReference.hasInElements ("references", uMLClass9) ) ;
                                     
                                    fujaba__Success = true ;
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                              fujaba__Success = false ;
                           }
                            
                           if ( !(fujaba__Success) )
                           {
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object uMLAttr6 is really bound
                                 JavaSDM.ensure ( uMLAttr6 != null ) ;
                                  
                                 // check object uMLClass9 is really bound
                                 JavaSDM.ensure ( uMLClass9 != null ) ;
                                  
                                 // create object
                                 multiReference = new MultiReferenceAnnotation ( ) ;
                                  
                                 // create link
                                 multiReference.addToElements ("field", uMLAttr6);
                                  
                                 // create link
                                 multiReference.addToElements ("references", uMLClass9);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              try
                              {
                                 fujaba__Success = false ;
                                  
                                 // check object containerAccess8 is really bound
                                 JavaSDM.ensure ( containerAccess8 != null ) ;
                                  
                                 // check object multiReference is really bound
                                 JavaSDM.ensure ( multiReference != null ) ;
                                  
                                 // create link
                                 multiReference.addToAntecedentAnnos (containerAccess8);
                                  
                                 fujaba__Success = true ;
                              }
                              catch ( JavaSDMException fujaba__InternalException )
                              {
                                 fujaba__Success = false ;
                              }
                               
                              return (multiReference) ;
                           }
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiReference is really bound
            JavaSDM.ensure ( multiReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("references", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass14 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLParam15: UMLParam
            fujaba__IterUMLClass14RevParamTypeUMLParam15 = uMLClass14.iteratorOfRevParamType () ;
            while ( fujaba__IterUMLClass14RevParamTypeUMLParam15.hasNext () )
            {
               try
               {
                  uMLParam15 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterUMLClass14RevParamTypeUMLParam15.next () ;
                   
                  // bind containerAccess13: ContainerAccessAnnotation
                  fujaba__IterUMLParam15AnnotationsContainerAccess13 = uMLParam15.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLParam15AnnotationsContainerAccess13.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLParam15AnnotationsContainerAccess13.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                        containerAccess13 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between containerAccess13 and uMLParam15
                        JavaSDM.ensure ( containerAccess13.hasInElements ("param", uMLParam15) ) ;
                         
                        // bind uMLAttr11: UMLAttr
                        fujaba__IterContainerAccess13ElementsUMLAttr11 = containerAccess13.iteratorOfElements ("field") ;
                        while ( fujaba__IterContainerAccess13ElementsUMLAttr11.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterContainerAccess13ElementsUMLAttr11.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                              uMLAttr11 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                               
                              // check To-Many-Link 'annotations' between uMLAttr11 and qualifiedReference12
                              fujaba__IterUMLAttr11AnnotationsQualifiedReference12 = uMLAttr11.iteratorOfAnnotations () ;
                              while ( fujaba__IterUMLAttr11AnnotationsQualifiedReference12.hasNext () )
                              {
                                 fujaba__TmpObject = fujaba__IterUMLAttr11AnnotationsQualifiedReference12.next () ;
                                  
                                 if ( fujaba__TmpObject instanceof QualifiedReferenceAnnotation )
                                 {
                                    qualifiedReference12 = (QualifiedReferenceAnnotation) fujaba__TmpObject ;
                                     
                                    JavaSDM.ensure ( !(qualifiedReference12.hasInElements ("field", uMLAttr11)) ) ;
                                 }
                              } // while
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object uMLAttr11 is really bound
                                    JavaSDM.ensure ( uMLAttr11 != null ) ;
                                     
                                    // check object uMLClass14 is really bound
                                    JavaSDM.ensure ( uMLClass14 != null ) ;
                                     
                                    // bind multiReference: MultiReferenceAnnotation
                                    fujaba__IterUMLClass14AnnotationsMultiReference = uMLClass14.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterUMLClass14AnnotationsMultiReference.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterUMLClass14AnnotationsMultiReference.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof MultiReferenceAnnotation ) ;
                                          multiReference = (MultiReferenceAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between multiReference and uMLClass14
                                          JavaSDM.ensure ( multiReference.hasInElements ("references", uMLClass14) ) ;
                                           
                                          // check To-Many-Link 'elements' between multiReference and uMLAttr11
                                          JavaSDM.ensure ( multiReference.hasInElements ("field", uMLAttr11) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object uMLAttr11 is really bound
                                       JavaSDM.ensure ( uMLAttr11 != null ) ;
                                        
                                       // check object uMLClass14 is really bound
                                       JavaSDM.ensure ( uMLClass14 != null ) ;
                                        
                                       // create object
                                       multiReference = new MultiReferenceAnnotation ( ) ;
                                        
                                       // create link
                                       multiReference.addToElements ("field", uMLAttr11);
                                        
                                       // create link
                                       multiReference.addToElements ("references", uMLClass14);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object containerAccess13 is really bound
                                       JavaSDM.ensure ( containerAccess13 != null ) ;
                                        
                                       // check object multiReference is really bound
                                       JavaSDM.ensure ( multiReference != null ) ;
                                        
                                       // create link
                                       multiReference.addToAntecedentAnnos (containerAccess13);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (multiReference) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object multiReference is really bound
            JavaSDM.ensure ( multiReference != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("references", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (multiReference) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("references", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof QualifiedReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ContainerAccessAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      ContainerAccessAnnotation containerAccess17 = null ;
      Iterator fujaba__IterContainerAccess17ElementsUMLAttr18 = null ;
      Iterator fujaba__IterContainerAccess17ElementsUMLAttr19 = null ;
      Iterator fujaba__IterUMLClass14RevParamTypeUMLParam16 = null ;
      Iterator fujaba__IterUMLClass14RevParamTypeUMLParam20 = null ;
      Iterator fujaba__IterUMLParam16AnnotationsContainerAccess17 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr11 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr18 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr uMLAttr19 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass14 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam16 = null ;
      de.uni_paderborn.fujaba.uml.UMLParam uMLParam20 = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("QualifiedReference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr11 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLAttr11);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass14 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLParam16: UMLParam
            fujaba__IterUMLClass14RevParamTypeUMLParam16 = uMLClass14.iteratorOfRevParamType () ;
            while ( fujaba__IterUMLClass14RevParamTypeUMLParam16.hasNext () )
            {
               try
               {
                  uMLParam16 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterUMLClass14RevParamTypeUMLParam16.next () ;
                   
                  // bind containerAccess17: ContainerAccessAnnotation
                  fujaba__IterUMLParam16AnnotationsContainerAccess17 = uMLParam16.iteratorOfAnnotations () ;
                  while ( fujaba__IterUMLParam16AnnotationsContainerAccess17.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterUMLParam16AnnotationsContainerAccess17.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ContainerAccessAnnotation ) ;
                        containerAccess17 = (ContainerAccessAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between containerAccess17 and uMLParam16
                        JavaSDM.ensure ( containerAccess17.hasInElements ("param", uMLParam16) ) ;
                         
                        // bind uMLAttr18: UMLAttr
                        fujaba__IterContainerAccess17ElementsUMLAttr18 = containerAccess17.iteratorOfElements ("field") ;
                        while ( fujaba__IterContainerAccess17ElementsUMLAttr18.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterContainerAccess17ElementsUMLAttr18.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                              uMLAttr18 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                               
                              {
                                 //  for each flow
                                 set.add (uMLAttr18);
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ContainerAccessAnnotation ) ;
             
            // explicit type cast
            containerAccess17 = (ContainerAccessAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind uMLAttr19: UMLAttr
            fujaba__IterContainerAccess17ElementsUMLAttr19 = containerAccess17.iteratorOfElements ("field") ;
            while ( fujaba__IterContainerAccess17ElementsUMLAttr19.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterContainerAccess17ElementsUMLAttr19.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  uMLAttr19 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                   
                  {
                     //  for each flow
                     set.add (uMLAttr19);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      if ( annotation.equals ("ContainerAccess") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            uMLAttr19 = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (uMLAttr19);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            uMLClass14 = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind uMLParam20: UMLParam
            fujaba__IterUMLClass14RevParamTypeUMLParam20 = uMLClass14.iteratorOfRevParamType () ;
            while ( fujaba__IterUMLClass14RevParamTypeUMLParam20.hasNext () )
            {
               try
               {
                  uMLParam20 = (de.uni_paderborn.fujaba.uml.UMLParam) fujaba__IterUMLClass14RevParamTypeUMLParam20.next () ;
                   
                  {
                     //  for each flow
                     set.add (uMLParam20);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
