package de.upb.inferenceengine.engines;

import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLClass;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.ASTRootNode;
import de.upb.javaast.methodast.PrimaryExpressionNode;
import de.upb.javaast.methodast.IdentifierNode;
import de.upb.javaast.methodast.MethodCallNode;

public class NeighborCallEngine
extends GFRNEngine
{
   private  NeighborCallEngine()
   {
   }

   private static NeighborCallEngine theNeighborCallEngine;

   public static NeighborCallEngine get()
   {
      if (theNeighborCallEngine == null)
      {
         theNeighborCallEngine = new NeighborCallEngine ();
      }
      return theNeighborCallEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode14 = null ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode17 = null ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode2 = null ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode5 = null ;
      ASTPathVisitor fujaba__IterRootToPrimaryExpressionNode8 = null ;
      ASTPathVisitorBottomUp fujaba__IterPrimaryExpressionNode11ToRoot = null ;
      ASTPathVisitorBottomUp fujaba__IterPrimaryExpressionNode20ToRoot = null ;
      de.uni_paderborn.fujaba.uml.ASTRootNode root = null ;
      Iterator fujaba__IterAttrAnnotationsReference1 = null ;
      Iterator fujaba__IterAttrAnnotationsReference10 = null ;
      Iterator fujaba__IterAttrAnnotationsReference19 = null ;
      Iterator fujaba__IterAttrAnnotationsReference7 = null ;
      Iterator fujaba__IterCalleeClassAnnotationsNeighborCall = null ;
      Iterator fujaba__IterCalleeClassAnnotationsReference13 = null ;
      Iterator fujaba__IterCalleeClassAnnotationsReference16 = null ;
      Iterator fujaba__IterCalleeClassMethodsCallee = null ;
      Iterator fujaba__IterCallerAnnotationsNeighborCall = null ;
      Iterator fujaba__IterCallerClassAttrsAttr = null ;
      Iterator fujaba__IterCallerClassMethodsCaller = null ;
      Iterator fujaba__IterId1AnnotationsNeighborCall = null ;
      Iterator fujaba__IterId2AnnotationsNeighborCall = null ;
      Iterator fujaba__IterReference10ElementsCalleeClass = null ;
      Iterator fujaba__IterReference13ElementsAttr = null ;
      Iterator fujaba__IterReference16ElementsAttr = null ;
      Iterator fujaba__IterReference19ElementsCalleeClass = null ;
      Iterator fujaba__IterReference1ElementsCalleeClass = null ;
      Iterator fujaba__IterReference4ElementsAttr = null ;
      Iterator fujaba__IterReference4ElementsCalleeClass = null ;
      Iterator fujaba__IterReference7ElementsCalleeClass = null ;
      de.upb.javaast.methodast.IdentifierNode id1 = null ;
      de.upb.javaast.methodast.IdentifierNode id2 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode12 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode15 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode18 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode21 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode3 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode6 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode9 = null ;
      NeighborCallAnnotation neighborCall = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode11 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode14 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode17 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode2 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode20 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode5 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode8 = null ;
      ReferenceAnnotation reference1 = null ;
      ReferenceAnnotation reference10 = null ;
      ReferenceAnnotation reference13 = null ;
      ReferenceAnnotation reference16 = null ;
      ReferenceAnnotation reference19 = null ;
      ReferenceAnnotation reference4 = null ;
      ReferenceAnnotation reference7 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr attr = null ;
      de.uni_paderborn.fujaba.uml.UMLClass calleeClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass callerClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("callerClass", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            callerClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind attr: UMLAttr
            fujaba__IterCallerClassAttrsAttr = callerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCallerClassAttrsAttr.hasNext () )
            {
               try
               {
                  attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsAttr.next () ;
                   
                  // bind caller: UMLMethod
                  fujaba__IterCallerClassMethodsCaller = callerClass.iteratorOfMethods () ;
                  while ( fujaba__IterCallerClassMethodsCaller.hasNext () )
                  {
                     try
                     {
                        caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCallerClassMethodsCaller.next () ;
                         
                        // bind root: ASTRootNode
                        root = caller.getASTRootNode () ;
                        JavaSDM.ensure ( root != null ) ;
                         
                        // bind reference1: ReferenceAnnotation
                        fujaba__IterAttrAnnotationsReference1 = attr.iteratorOfAnnotations () ;
                        while ( fujaba__IterAttrAnnotationsReference1.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAttrAnnotationsReference1.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                              reference1 = (ReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between reference1 and attr
                              JavaSDM.ensure ( reference1.hasInElements ("field", attr) ) ;
                               
                              // bind calleeClass: UMLClass
                              fujaba__IterReference1ElementsCalleeClass = reference1.iteratorOfElements ("references") ;
                              while ( fujaba__IterReference1ElementsCalleeClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterReference1ElementsCalleeClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                     
                                    // bind callee: UMLMethod
                                    fujaba__IterCalleeClassMethodsCallee = calleeClass.iteratorOfMethods () ;
                                    while ( fujaba__IterCalleeClassMethodsCallee.hasNext () )
                                    {
                                       try
                                       {
                                          callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCalleeClassMethodsCallee.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                           
                                          // Path search between ASTRootNode and PrimaryExpressionNode
                                          // Bind primaryExpressionNode2 : PrimaryExpressionNode
                                          fujaba__IterRootToPrimaryExpressionNode2 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                                          while ( fujaba__IterRootToPrimaryExpressionNode2.hasNext () )
                                          {
                                             try
                                             {
                                                primaryExpressionNode2 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode2.next () ;
                                                 
                                                // bind methodCallNode3: MethodCallNode
                                                fujaba__TmpObject = primaryExpressionNode2.getNextPrimaryExpression () ;
                                                JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                                                methodCallNode3 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(primaryExpressionNode2.equals (methodCallNode3)) ) ;
                                                 
                                                // bind id1: IdentifierNode
                                                id1 = primaryExpressionNode2.getIdentifier () ;
                                                JavaSDM.ensure ( id1 != null ) ;
                                                 
                                                // bind id2: IdentifierNode
                                                id2 = methodCallNode3.getIdentifier () ;
                                                JavaSDM.ensure ( id2 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                                 
                                                // constraint
                                                JavaSDM.ensure ( id1.getName().equals(attr.getName()) ) ;
                                                 
                                                // constraint
                                                JavaSDM.ensure ( id2.getName().equals(callee.getName()) ) ;
                                                 
                                                {
                                                   //  for each flow
                                                   try
                                                   {
                                                      fujaba__Success = false ;
                                                       
                                                      // check object callerClass is really bound
                                                      JavaSDM.ensure ( callerClass != null ) ;
                                                       
                                                      // check object caller is really bound
                                                      JavaSDM.ensure ( caller != null ) ;
                                                       
                                                      // check object callee is really bound
                                                      JavaSDM.ensure ( callee != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                       
                                                      // check object calleeClass is really bound
                                                      JavaSDM.ensure ( calleeClass != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                       
                                                      // check object id1 is really bound
                                                      JavaSDM.ensure ( id1 != null ) ;
                                                       
                                                      // check object id2 is really bound
                                                      JavaSDM.ensure ( id2 != null ) ;
                                                       
                                                      // check isomorphic binding
                                                      JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                                       
                                                      // bind neighborCall: NeighborCallAnnotation
                                                      fujaba__IterId2AnnotationsNeighborCall = id2.iteratorOfAnnotations () ;
                                                      while ( !(fujaba__Success) && fujaba__IterId2AnnotationsNeighborCall.hasNext () )
                                                      {
                                                         try
                                                         {
                                                            fujaba__TmpObject = fujaba__IterId2AnnotationsNeighborCall.next () ;
                                                            JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                            neighborCall = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                             
                                                            // check Reverse-Qualified-Link 'elements' between neighborCall and id2
                                                            JavaSDM.ensure ( neighborCall.hasInElements ("methodCallIdentifier", id2) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between neighborCall and callerClass
                                                            JavaSDM.ensure ( neighborCall.hasInElements ("callerClass", callerClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between neighborCall and caller
                                                            JavaSDM.ensure ( neighborCall.hasInElements ("caller", caller) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between neighborCall and callee
                                                            JavaSDM.ensure ( neighborCall.hasInElements ("callee", callee) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between neighborCall and calleeClass
                                                            JavaSDM.ensure ( neighborCall.hasInElements ("calleeClass", calleeClass) ) ;
                                                             
                                                            // check To-Many-Link 'elements' between neighborCall and id1
                                                            JavaSDM.ensure ( neighborCall.hasInElements ("fieldIdentifier", id1) ) ;
                                                             
                                                            fujaba__Success = true ;
                                                         }
                                                         catch ( JavaSDMException fujaba__InternalException )
                                                         {
                                                         }
                                                      }
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                      fujaba__Success = false ;
                                                   }
                                                    
                                                   if ( !(fujaba__Success) )
                                                   {
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object callerClass is really bound
                                                         JavaSDM.ensure ( callerClass != null ) ;
                                                          
                                                         // check object caller is really bound
                                                         JavaSDM.ensure ( caller != null ) ;
                                                          
                                                         // check object callee is really bound
                                                         JavaSDM.ensure ( callee != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                          
                                                         // check object calleeClass is really bound
                                                         JavaSDM.ensure ( calleeClass != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                          
                                                         // check object id1 is really bound
                                                         JavaSDM.ensure ( id1 != null ) ;
                                                          
                                                         // check object id2 is really bound
                                                         JavaSDM.ensure ( id2 != null ) ;
                                                          
                                                         // check isomorphic binding
                                                         JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                                          
                                                         // check object attr is really bound
                                                         JavaSDM.ensure ( attr != null ) ;
                                                          
                                                         // check object root is really bound
                                                         JavaSDM.ensure ( root != null ) ;
                                                          
                                                         // create object
                                                         neighborCall = new NeighborCallAnnotation ( ) ;
                                                          
                                                         // create link
                                                         neighborCall.addToElements ("callerClass", callerClass);
                                                          
                                                         // create link
                                                         neighborCall.addToElements ("caller", caller);
                                                          
                                                         // create link
                                                         neighborCall.addToElements ("callee", callee);
                                                          
                                                         // create link
                                                         neighborCall.addToElements ("calleeClass", calleeClass);
                                                          
                                                         // create link
                                                         neighborCall.addToElements ("fieldIdentifier", id1);
                                                          
                                                         // create link
                                                         neighborCall.addToElements ("methodCallIdentifier", id2);
                                                          
                                                         // create link
                                                         neighborCall.addToBoundObjects ("callerClass", callerClass);
                                                          
                                                         // create link
                                                         neighborCall.addToBoundObjects ("attr", attr);
                                                          
                                                         // create link
                                                         neighborCall.addToBoundObjects ("caller", caller);
                                                          
                                                         // create link
                                                         neighborCall.addToBoundObjects ("root", root);
                                                          
                                                         // create link
                                                         neighborCall.addToBoundObjects ("id1", id1);
                                                          
                                                         // create link
                                                         neighborCall.addToBoundObjects ("callee", callee);
                                                          
                                                         // create link
                                                         neighborCall.addToBoundObjects ("calleeClass", calleeClass);
                                                          
                                                         // create link
                                                         neighborCall.addToBoundObjects ("id2", id2);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      try
                                                      {
                                                         fujaba__Success = false ;
                                                          
                                                         // check object reference1 is really bound
                                                         JavaSDM.ensure ( reference1 != null ) ;
                                                          
                                                         // check object neighborCall is really bound
                                                         JavaSDM.ensure ( neighborCall != null ) ;
                                                          
                                                         // create link
                                                         neighborCall.addToAntecedentAnnos (reference1);
                                                          
                                                         fujaba__Success = true ;
                                                      }
                                                      catch ( JavaSDMException fujaba__InternalException )
                                                      {
                                                         fujaba__Success = false ;
                                                      }
                                                       
                                                      return (neighborCall) ;
                                                   }
                                                } //  end for each flow
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object neighborCall is really bound
            JavaSDM.ensure ( neighborCall != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("callerClass", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof ReferenceAnnotation ) ;
             
            // explicit type cast
            reference4 = (ReferenceAnnotation) fujaba__tmpTypeCastObject ;
             
            // bind attr: UMLAttr
            fujaba__IterReference4ElementsAttr = reference4.iteratorOfElements ("field") ;
            while ( fujaba__IterReference4ElementsAttr.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterReference4ElementsAttr.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                  attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                   
                  // bind callerClass: UMLClass
                  callerClass = attr.getParent () ;
                  JavaSDM.ensure ( callerClass != null ) ;
                   
                  // bind calleeClass: UMLClass
                  fujaba__IterReference4ElementsCalleeClass = reference4.iteratorOfElements ("references") ;
                  while ( fujaba__IterReference4ElementsCalleeClass.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterReference4ElementsCalleeClass.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                        calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                         
                        // bind caller: UMLMethod
                        fujaba__IterCallerClassMethodsCaller = callerClass.iteratorOfMethods () ;
                        while ( fujaba__IterCallerClassMethodsCaller.hasNext () )
                        {
                           try
                           {
                              caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCallerClassMethodsCaller.next () ;
                               
                              // bind root: ASTRootNode
                              root = caller.getASTRootNode () ;
                              JavaSDM.ensure ( root != null ) ;
                               
                              // bind callee: UMLMethod
                              fujaba__IterCalleeClassMethodsCallee = calleeClass.iteratorOfMethods () ;
                              while ( fujaba__IterCalleeClassMethodsCallee.hasNext () )
                              {
                                 try
                                 {
                                    callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCalleeClassMethodsCallee.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                     
                                    // Path search between ASTRootNode and PrimaryExpressionNode
                                    // Bind primaryExpressionNode5 : PrimaryExpressionNode
                                    fujaba__IterRootToPrimaryExpressionNode5 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                                    while ( fujaba__IterRootToPrimaryExpressionNode5.hasNext () )
                                    {
                                       try
                                       {
                                          primaryExpressionNode5 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode5.next () ;
                                           
                                          // bind methodCallNode6: MethodCallNode
                                          fujaba__TmpObject = primaryExpressionNode5.getNextPrimaryExpression () ;
                                          JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                                          methodCallNode6 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(primaryExpressionNode5.equals (methodCallNode6)) ) ;
                                           
                                          // bind id1: IdentifierNode
                                          id1 = primaryExpressionNode5.getIdentifier () ;
                                          JavaSDM.ensure ( id1 != null ) ;
                                           
                                          // bind id2: IdentifierNode
                                          id2 = methodCallNode6.getIdentifier () ;
                                          JavaSDM.ensure ( id2 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id1.getName().equals(attr.getName()) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id2.getName().equals(callee.getName()) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object callerClass is really bound
                                                JavaSDM.ensure ( callerClass != null ) ;
                                                 
                                                // check object caller is really bound
                                                JavaSDM.ensure ( caller != null ) ;
                                                 
                                                // check object callee is really bound
                                                JavaSDM.ensure ( callee != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                 
                                                // check object calleeClass is really bound
                                                JavaSDM.ensure ( calleeClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                 
                                                // check object id1 is really bound
                                                JavaSDM.ensure ( id1 != null ) ;
                                                 
                                                // check object id2 is really bound
                                                JavaSDM.ensure ( id2 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                                 
                                                // bind neighborCall: NeighborCallAnnotation
                                                fujaba__IterId2AnnotationsNeighborCall = id2.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterId2AnnotationsNeighborCall.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterId2AnnotationsNeighborCall.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                      neighborCall = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between neighborCall and id2
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("methodCallIdentifier", id2) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and callerClass
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("callerClass", callerClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and caller
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("caller", caller) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and callee
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("callee", callee) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and calleeClass
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("calleeClass", calleeClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and id1
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("fieldIdentifier", id1) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object callerClass is really bound
                                                   JavaSDM.ensure ( callerClass != null ) ;
                                                    
                                                   // check object caller is really bound
                                                   JavaSDM.ensure ( caller != null ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                    
                                                   // check object calleeClass is really bound
                                                   JavaSDM.ensure ( calleeClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                    
                                                   // check object id1 is really bound
                                                   JavaSDM.ensure ( id1 != null ) ;
                                                    
                                                   // check object id2 is really bound
                                                   JavaSDM.ensure ( id2 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                                    
                                                   // check object attr is really bound
                                                   JavaSDM.ensure ( attr != null ) ;
                                                    
                                                   // check object root is really bound
                                                   JavaSDM.ensure ( root != null ) ;
                                                    
                                                   // create object
                                                   neighborCall = new NeighborCallAnnotation ( ) ;
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("caller", caller);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("callee", callee);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("fieldIdentifier", id1);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("methodCallIdentifier", id2);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("attr", attr);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("caller", caller);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("root", root);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("id1", id1);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("callee", callee);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("id2", id2);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference4 is really bound
                                                   JavaSDM.ensure ( reference4 != null ) ;
                                                    
                                                   // check object neighborCall is really bound
                                                   JavaSDM.ensure ( neighborCall != null ) ;
                                                    
                                                   // create link
                                                   neighborCall.addToAntecedentAnnos (reference4);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (neighborCall) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object neighborCall is really bound
            JavaSDM.ensure ( neighborCall != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("trigger", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("caller", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind root: ASTRootNode
            root = caller.getASTRootNode () ;
            JavaSDM.ensure ( root != null ) ;
             
            // bind callerClass: UMLClass
            callerClass = caller.getParent () ;
            JavaSDM.ensure ( callerClass != null ) ;
             
            // bind attr: UMLAttr
            fujaba__IterCallerClassAttrsAttr = callerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCallerClassAttrsAttr.hasNext () )
            {
               try
               {
                  attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsAttr.next () ;
                   
                  // bind reference7: ReferenceAnnotation
                  fujaba__IterAttrAnnotationsReference7 = attr.iteratorOfAnnotations () ;
                  while ( fujaba__IterAttrAnnotationsReference7.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterAttrAnnotationsReference7.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                        reference7 = (ReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between reference7 and attr
                        JavaSDM.ensure ( reference7.hasInElements ("field", attr) ) ;
                         
                        // bind calleeClass: UMLClass
                        fujaba__IterReference7ElementsCalleeClass = reference7.iteratorOfElements ("references") ;
                        while ( fujaba__IterReference7ElementsCalleeClass.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReference7ElementsCalleeClass.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                              calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                               
                              // bind callee: UMLMethod
                              fujaba__IterCalleeClassMethodsCallee = calleeClass.iteratorOfMethods () ;
                              while ( fujaba__IterCalleeClassMethodsCallee.hasNext () )
                              {
                                 try
                                 {
                                    callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCalleeClassMethodsCallee.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                     
                                    // Path search between ASTRootNode and PrimaryExpressionNode
                                    // Bind primaryExpressionNode8 : PrimaryExpressionNode
                                    fujaba__IterRootToPrimaryExpressionNode8 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                                    while ( fujaba__IterRootToPrimaryExpressionNode8.hasNext () )
                                    {
                                       try
                                       {
                                          primaryExpressionNode8 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode8.next () ;
                                           
                                          // bind methodCallNode9: MethodCallNode
                                          fujaba__TmpObject = primaryExpressionNode8.getNextPrimaryExpression () ;
                                          JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                                          methodCallNode9 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(primaryExpressionNode8.equals (methodCallNode9)) ) ;
                                           
                                          // bind id1: IdentifierNode
                                          id1 = primaryExpressionNode8.getIdentifier () ;
                                          JavaSDM.ensure ( id1 != null ) ;
                                           
                                          // bind id2: IdentifierNode
                                          id2 = methodCallNode9.getIdentifier () ;
                                          JavaSDM.ensure ( id2 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id1.getName().equals(attr.getName()) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id2.getName().equals(callee.getName()) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object callerClass is really bound
                                                JavaSDM.ensure ( callerClass != null ) ;
                                                 
                                                // check object caller is really bound
                                                JavaSDM.ensure ( caller != null ) ;
                                                 
                                                // check object callee is really bound
                                                JavaSDM.ensure ( callee != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                 
                                                // check object calleeClass is really bound
                                                JavaSDM.ensure ( calleeClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                 
                                                // check object id1 is really bound
                                                JavaSDM.ensure ( id1 != null ) ;
                                                 
                                                // check object id2 is really bound
                                                JavaSDM.ensure ( id2 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                                 
                                                // bind neighborCall: NeighborCallAnnotation
                                                fujaba__IterCallerAnnotationsNeighborCall = caller.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterCallerAnnotationsNeighborCall.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterCallerAnnotationsNeighborCall.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                      neighborCall = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between neighborCall and caller
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("caller", caller) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and callerClass
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("callerClass", callerClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and callee
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("callee", callee) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and calleeClass
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("calleeClass", calleeClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and id1
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("fieldIdentifier", id1) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and id2
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("methodCallIdentifier", id2) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object callerClass is really bound
                                                   JavaSDM.ensure ( callerClass != null ) ;
                                                    
                                                   // check object caller is really bound
                                                   JavaSDM.ensure ( caller != null ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                    
                                                   // check object calleeClass is really bound
                                                   JavaSDM.ensure ( calleeClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                    
                                                   // check object id1 is really bound
                                                   JavaSDM.ensure ( id1 != null ) ;
                                                    
                                                   // check object id2 is really bound
                                                   JavaSDM.ensure ( id2 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                                    
                                                   // check object attr is really bound
                                                   JavaSDM.ensure ( attr != null ) ;
                                                    
                                                   // check object root is really bound
                                                   JavaSDM.ensure ( root != null ) ;
                                                    
                                                   // create object
                                                   neighborCall = new NeighborCallAnnotation ( ) ;
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("caller", caller);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("callee", callee);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("fieldIdentifier", id1);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("methodCallIdentifier", id2);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("attr", attr);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("caller", caller);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("root", root);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("id1", id1);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("callee", callee);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("id2", id2);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference7 is really bound
                                                   JavaSDM.ensure ( reference7 != null ) ;
                                                    
                                                   // check object neighborCall is really bound
                                                   JavaSDM.ensure ( neighborCall != null ) ;
                                                    
                                                   // create link
                                                   neighborCall.addToAntecedentAnnos (reference7);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (neighborCall) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object neighborCall is really bound
            JavaSDM.ensure ( neighborCall != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("caller", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("fieldIdentifier", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.upb.javaast.methodast.IdentifierNode ) ;
             
            // explicit type cast
            id1 = (de.upb.javaast.methodast.IdentifierNode) fujaba__tmpTypeCastObject ;
             
            // bind primaryExpressionNode11: PrimaryExpressionNode
            primaryExpressionNode11 = id1.getPrimaryExpression () ;
            JavaSDM.ensure ( primaryExpressionNode11 != null ) ;
             
            // bind methodCallNode12: MethodCallNode
            fujaba__TmpObject = primaryExpressionNode11.getNextPrimaryExpression () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
            methodCallNode12 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
             
            // check isomorphic binding
            JavaSDM.ensure ( !(primaryExpressionNode11.equals (methodCallNode12)) ) ;
             
            // bind id2: IdentifierNode
            id2 = methodCallNode12.getIdentifier () ;
            JavaSDM.ensure ( id2 != null ) ;
             
            // check isomorphic binding
            JavaSDM.ensure ( !(id1.equals (id2)) ) ;
             
            // Path search between PrimaryExpressionNode and ASTRootNode
            // Bind root : ASTRootNode
            fujaba__IterPrimaryExpressionNode11ToRoot = new ASTPathVisitorBottomUp (primaryExpressionNode11, ASTRootNode.class ) ;
            while ( fujaba__IterPrimaryExpressionNode11ToRoot.hasNext () )
            {
               try
               {
                  root = (de.uni_paderborn.fujaba.uml.ASTRootNode) fujaba__IterPrimaryExpressionNode11ToRoot.next () ;
                   
                  // bind caller: UMLMethod
                  caller = root.getMethod () ;
                  JavaSDM.ensure ( caller != null ) ;
                   
                  // bind callerClass: UMLClass
                  callerClass = caller.getParent () ;
                  JavaSDM.ensure ( callerClass != null ) ;
                   
                  // bind attr: UMLAttr
                  fujaba__IterCallerClassAttrsAttr = callerClass.iteratorOfAttrs () ;
                  while ( fujaba__IterCallerClassAttrsAttr.hasNext () )
                  {
                     try
                     {
                        attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsAttr.next () ;
                         
                        // bind reference10: ReferenceAnnotation
                        fujaba__IterAttrAnnotationsReference10 = attr.iteratorOfAnnotations () ;
                        while ( fujaba__IterAttrAnnotationsReference10.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAttrAnnotationsReference10.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                              reference10 = (ReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between reference10 and attr
                              JavaSDM.ensure ( reference10.hasInElements ("field", attr) ) ;
                               
                              // bind calleeClass: UMLClass
                              fujaba__IterReference10ElementsCalleeClass = reference10.iteratorOfElements ("references") ;
                              while ( fujaba__IterReference10ElementsCalleeClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterReference10ElementsCalleeClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                     
                                    // bind callee: UMLMethod
                                    fujaba__IterCalleeClassMethodsCallee = calleeClass.iteratorOfMethods () ;
                                    while ( fujaba__IterCalleeClassMethodsCallee.hasNext () )
                                    {
                                       try
                                       {
                                          callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCalleeClassMethodsCallee.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id1.getName().equals(attr.getName()) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id2.getName().equals(callee.getName()) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object callerClass is really bound
                                                JavaSDM.ensure ( callerClass != null ) ;
                                                 
                                                // check object caller is really bound
                                                JavaSDM.ensure ( caller != null ) ;
                                                 
                                                // check object callee is really bound
                                                JavaSDM.ensure ( callee != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                 
                                                // check object calleeClass is really bound
                                                JavaSDM.ensure ( calleeClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                 
                                                // check object id1 is really bound
                                                JavaSDM.ensure ( id1 != null ) ;
                                                 
                                                // check object id2 is really bound
                                                JavaSDM.ensure ( id2 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                                 
                                                // bind neighborCall: NeighborCallAnnotation
                                                fujaba__IterId1AnnotationsNeighborCall = id1.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterId1AnnotationsNeighborCall.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterId1AnnotationsNeighborCall.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                      neighborCall = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between neighborCall and id1
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("fieldIdentifier", id1) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and callerClass
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("callerClass", callerClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and caller
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("caller", caller) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and callee
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("callee", callee) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and calleeClass
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("calleeClass", calleeClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and id2
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("methodCallIdentifier", id2) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object callerClass is really bound
                                                   JavaSDM.ensure ( callerClass != null ) ;
                                                    
                                                   // check object caller is really bound
                                                   JavaSDM.ensure ( caller != null ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                    
                                                   // check object calleeClass is really bound
                                                   JavaSDM.ensure ( calleeClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                    
                                                   // check object id1 is really bound
                                                   JavaSDM.ensure ( id1 != null ) ;
                                                    
                                                   // check object id2 is really bound
                                                   JavaSDM.ensure ( id2 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                                    
                                                   // check object attr is really bound
                                                   JavaSDM.ensure ( attr != null ) ;
                                                    
                                                   // check object root is really bound
                                                   JavaSDM.ensure ( root != null ) ;
                                                    
                                                   // create object
                                                   neighborCall = new NeighborCallAnnotation ( ) ;
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("caller", caller);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("callee", callee);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("fieldIdentifier", id1);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("methodCallIdentifier", id2);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("attr", attr);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("caller", caller);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("root", root);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("id1", id1);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("callee", callee);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("id2", id2);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference10 is really bound
                                                   JavaSDM.ensure ( reference10 != null ) ;
                                                    
                                                   // check object neighborCall is really bound
                                                   JavaSDM.ensure ( neighborCall != null ) ;
                                                    
                                                   // create link
                                                   neighborCall.addToAntecedentAnnos (reference10);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (neighborCall) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object neighborCall is really bound
            JavaSDM.ensure ( neighborCall != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("fieldIdentifier", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("callee", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind calleeClass: UMLClass
            calleeClass = callee.getParent () ;
            JavaSDM.ensure ( calleeClass != null ) ;
             
            // bind reference13: ReferenceAnnotation
            fujaba__IterCalleeClassAnnotationsReference13 = calleeClass.iteratorOfAnnotations () ;
            while ( fujaba__IterCalleeClassAnnotationsReference13.hasNext () )
            {
               try
               {
                  fujaba__TmpObject = fujaba__IterCalleeClassAnnotationsReference13.next () ;
                  JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                  reference13 = (ReferenceAnnotation) fujaba__TmpObject ;
                   
                  // check Reverse-Qualified-Link 'elements' between reference13 and calleeClass
                  JavaSDM.ensure ( reference13.hasInElements ("references", calleeClass) ) ;
                   
                  // bind attr: UMLAttr
                  fujaba__IterReference13ElementsAttr = reference13.iteratorOfElements ("field") ;
                  while ( fujaba__IterReference13ElementsAttr.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterReference13ElementsAttr.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                        attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                         
                        // bind callerClass: UMLClass
                        callerClass = attr.getParent () ;
                        JavaSDM.ensure ( callerClass != null ) ;
                         
                        // check isomorphic binding
                        JavaSDM.ensure ( !(calleeClass.equals (callerClass)) ) ;
                         
                        // bind caller: UMLMethod
                        fujaba__IterCallerClassMethodsCaller = callerClass.iteratorOfMethods () ;
                        while ( fujaba__IterCallerClassMethodsCaller.hasNext () )
                        {
                           try
                           {
                              caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCallerClassMethodsCaller.next () ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                               
                              // bind root: ASTRootNode
                              root = caller.getASTRootNode () ;
                              JavaSDM.ensure ( root != null ) ;
                               
                              // Path search between ASTRootNode and PrimaryExpressionNode
                              // Bind primaryExpressionNode14 : PrimaryExpressionNode
                              fujaba__IterRootToPrimaryExpressionNode14 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                              while ( fujaba__IterRootToPrimaryExpressionNode14.hasNext () )
                              {
                                 try
                                 {
                                    primaryExpressionNode14 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode14.next () ;
                                     
                                    // bind methodCallNode15: MethodCallNode
                                    fujaba__TmpObject = primaryExpressionNode14.getNextPrimaryExpression () ;
                                    JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                                    methodCallNode15 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(primaryExpressionNode14.equals (methodCallNode15)) ) ;
                                     
                                    // bind id1: IdentifierNode
                                    id1 = primaryExpressionNode14.getIdentifier () ;
                                    JavaSDM.ensure ( id1 != null ) ;
                                     
                                    // bind id2: IdentifierNode
                                    id2 = methodCallNode15.getIdentifier () ;
                                    JavaSDM.ensure ( id2 != null ) ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( id1.getName().equals(attr.getName()) ) ;
                                     
                                    // constraint
                                    JavaSDM.ensure ( id2.getName().equals(callee.getName()) ) ;
                                     
                                    {
                                       //  for each flow
                                       try
                                       {
                                          fujaba__Success = false ;
                                           
                                          // check object callerClass is really bound
                                          JavaSDM.ensure ( callerClass != null ) ;
                                           
                                          // check object caller is really bound
                                          JavaSDM.ensure ( caller != null ) ;
                                           
                                          // check object callee is really bound
                                          JavaSDM.ensure ( callee != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                           
                                          // check object calleeClass is really bound
                                          JavaSDM.ensure ( calleeClass != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                           
                                          // check object id1 is really bound
                                          JavaSDM.ensure ( id1 != null ) ;
                                           
                                          // check object id2 is really bound
                                          JavaSDM.ensure ( id2 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                           
                                          // bind neighborCall: NeighborCallAnnotation
                                          fujaba__IterId2AnnotationsNeighborCall = id2.iteratorOfAnnotations () ;
                                          while ( !(fujaba__Success) && fujaba__IterId2AnnotationsNeighborCall.hasNext () )
                                          {
                                             try
                                             {
                                                fujaba__TmpObject = fujaba__IterId2AnnotationsNeighborCall.next () ;
                                                JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                neighborCall = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                 
                                                // check Reverse-Qualified-Link 'elements' between neighborCall and id2
                                                JavaSDM.ensure ( neighborCall.hasInElements ("methodCallIdentifier", id2) ) ;
                                                 
                                                // check To-Many-Link 'elements' between neighborCall and callerClass
                                                JavaSDM.ensure ( neighborCall.hasInElements ("callerClass", callerClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between neighborCall and caller
                                                JavaSDM.ensure ( neighborCall.hasInElements ("caller", caller) ) ;
                                                 
                                                // check To-Many-Link 'elements' between neighborCall and callee
                                                JavaSDM.ensure ( neighborCall.hasInElements ("callee", callee) ) ;
                                                 
                                                // check To-Many-Link 'elements' between neighborCall and calleeClass
                                                JavaSDM.ensure ( neighborCall.hasInElements ("calleeClass", calleeClass) ) ;
                                                 
                                                // check To-Many-Link 'elements' between neighborCall and id1
                                                JavaSDM.ensure ( neighborCall.hasInElements ("fieldIdentifier", id1) ) ;
                                                 
                                                fujaba__Success = true ;
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                             }
                                          }
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                          fujaba__Success = false ;
                                       }
                                        
                                       if ( !(fujaba__Success) )
                                       {
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object callerClass is really bound
                                             JavaSDM.ensure ( callerClass != null ) ;
                                              
                                             // check object caller is really bound
                                             JavaSDM.ensure ( caller != null ) ;
                                              
                                             // check object callee is really bound
                                             JavaSDM.ensure ( callee != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                              
                                             // check object calleeClass is really bound
                                             JavaSDM.ensure ( calleeClass != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                              
                                             // check object id1 is really bound
                                             JavaSDM.ensure ( id1 != null ) ;
                                              
                                             // check object id2 is really bound
                                             JavaSDM.ensure ( id2 != null ) ;
                                              
                                             // check isomorphic binding
                                             JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                              
                                             // check object attr is really bound
                                             JavaSDM.ensure ( attr != null ) ;
                                              
                                             // check object root is really bound
                                             JavaSDM.ensure ( root != null ) ;
                                              
                                             // create object
                                             neighborCall = new NeighborCallAnnotation ( ) ;
                                              
                                             // create link
                                             neighborCall.addToElements ("callerClass", callerClass);
                                              
                                             // create link
                                             neighborCall.addToElements ("caller", caller);
                                              
                                             // create link
                                             neighborCall.addToElements ("callee", callee);
                                              
                                             // create link
                                             neighborCall.addToElements ("calleeClass", calleeClass);
                                              
                                             // create link
                                             neighborCall.addToElements ("fieldIdentifier", id1);
                                              
                                             // create link
                                             neighborCall.addToElements ("methodCallIdentifier", id2);
                                              
                                             // create link
                                             neighborCall.addToBoundObjects ("callerClass", callerClass);
                                              
                                             // create link
                                             neighborCall.addToBoundObjects ("attr", attr);
                                              
                                             // create link
                                             neighborCall.addToBoundObjects ("caller", caller);
                                              
                                             // create link
                                             neighborCall.addToBoundObjects ("root", root);
                                              
                                             // create link
                                             neighborCall.addToBoundObjects ("id1", id1);
                                              
                                             // create link
                                             neighborCall.addToBoundObjects ("callee", callee);
                                              
                                             // create link
                                             neighborCall.addToBoundObjects ("calleeClass", calleeClass);
                                              
                                             // create link
                                             neighborCall.addToBoundObjects ("id2", id2);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          try
                                          {
                                             fujaba__Success = false ;
                                              
                                             // check object reference13 is really bound
                                             JavaSDM.ensure ( reference13 != null ) ;
                                              
                                             // check object neighborCall is really bound
                                             JavaSDM.ensure ( neighborCall != null ) ;
                                              
                                             // create link
                                             neighborCall.addToAntecedentAnnos (reference13);
                                              
                                             fujaba__Success = true ;
                                          }
                                          catch ( JavaSDMException fujaba__InternalException )
                                          {
                                             fujaba__Success = false ;
                                          }
                                           
                                          return (neighborCall) ;
                                       }
                                    } //  end for each flow
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object neighborCall is really bound
            JavaSDM.ensure ( neighborCall != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("callee", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("calleeClass", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind callee: UMLMethod
            fujaba__IterCalleeClassMethodsCallee = calleeClass.iteratorOfMethods () ;
            while ( fujaba__IterCalleeClassMethodsCallee.hasNext () )
            {
               try
               {
                  callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCalleeClassMethodsCallee.next () ;
                   
                  // bind reference16: ReferenceAnnotation
                  fujaba__IterCalleeClassAnnotationsReference16 = calleeClass.iteratorOfAnnotations () ;
                  while ( fujaba__IterCalleeClassAnnotationsReference16.hasNext () )
                  {
                     try
                     {
                        fujaba__TmpObject = fujaba__IterCalleeClassAnnotationsReference16.next () ;
                        JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                        reference16 = (ReferenceAnnotation) fujaba__TmpObject ;
                         
                        // check Reverse-Qualified-Link 'elements' between reference16 and calleeClass
                        JavaSDM.ensure ( reference16.hasInElements ("references", calleeClass) ) ;
                         
                        // bind attr: UMLAttr
                        fujaba__IterReference16ElementsAttr = reference16.iteratorOfElements ("field") ;
                        while ( fujaba__IterReference16ElementsAttr.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterReference16ElementsAttr.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
                              attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__TmpObject ;
                               
                              // bind callerClass: UMLClass
                              callerClass = attr.getParent () ;
                              JavaSDM.ensure ( callerClass != null ) ;
                               
                              // check isomorphic binding
                              JavaSDM.ensure ( !(calleeClass.equals (callerClass)) ) ;
                               
                              // bind caller: UMLMethod
                              fujaba__IterCallerClassMethodsCaller = callerClass.iteratorOfMethods () ;
                              while ( fujaba__IterCallerClassMethodsCaller.hasNext () )
                              {
                                 try
                                 {
                                    caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCallerClassMethodsCaller.next () ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(callee.equals (caller)) ) ;
                                     
                                    // bind root: ASTRootNode
                                    root = caller.getASTRootNode () ;
                                    JavaSDM.ensure ( root != null ) ;
                                     
                                    // Path search between ASTRootNode and PrimaryExpressionNode
                                    // Bind primaryExpressionNode17 : PrimaryExpressionNode
                                    fujaba__IterRootToPrimaryExpressionNode17 = new ASTPathVisitor (root, PrimaryExpressionNode.class ) ;
                                    while ( fujaba__IterRootToPrimaryExpressionNode17.hasNext () )
                                    {
                                       try
                                       {
                                          primaryExpressionNode17 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterRootToPrimaryExpressionNode17.next () ;
                                           
                                          // bind methodCallNode18: MethodCallNode
                                          fujaba__TmpObject = primaryExpressionNode17.getNextPrimaryExpression () ;
                                          JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
                                          methodCallNode18 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(primaryExpressionNode17.equals (methodCallNode18)) ) ;
                                           
                                          // bind id1: IdentifierNode
                                          id1 = primaryExpressionNode17.getIdentifier () ;
                                          JavaSDM.ensure ( id1 != null ) ;
                                           
                                          // bind id2: IdentifierNode
                                          id2 = methodCallNode18.getIdentifier () ;
                                          JavaSDM.ensure ( id2 != null ) ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id1.getName().equals(attr.getName()) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id2.getName().equals(callee.getName()) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object callerClass is really bound
                                                JavaSDM.ensure ( callerClass != null ) ;
                                                 
                                                // check object caller is really bound
                                                JavaSDM.ensure ( caller != null ) ;
                                                 
                                                // check object callee is really bound
                                                JavaSDM.ensure ( callee != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                 
                                                // check object calleeClass is really bound
                                                JavaSDM.ensure ( calleeClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                 
                                                // check object id1 is really bound
                                                JavaSDM.ensure ( id1 != null ) ;
                                                 
                                                // check object id2 is really bound
                                                JavaSDM.ensure ( id2 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                                 
                                                // bind neighborCall: NeighborCallAnnotation
                                                fujaba__IterCalleeClassAnnotationsNeighborCall = calleeClass.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterCalleeClassAnnotationsNeighborCall.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterCalleeClassAnnotationsNeighborCall.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                      neighborCall = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between neighborCall and calleeClass
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("calleeClass", calleeClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and callerClass
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("callerClass", callerClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and caller
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("caller", caller) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and callee
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("callee", callee) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and id1
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("fieldIdentifier", id1) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and id2
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("methodCallIdentifier", id2) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object callerClass is really bound
                                                   JavaSDM.ensure ( callerClass != null ) ;
                                                    
                                                   // check object caller is really bound
                                                   JavaSDM.ensure ( caller != null ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                    
                                                   // check object calleeClass is really bound
                                                   JavaSDM.ensure ( calleeClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                    
                                                   // check object id1 is really bound
                                                   JavaSDM.ensure ( id1 != null ) ;
                                                    
                                                   // check object id2 is really bound
                                                   JavaSDM.ensure ( id2 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                                    
                                                   // check object attr is really bound
                                                   JavaSDM.ensure ( attr != null ) ;
                                                    
                                                   // check object root is really bound
                                                   JavaSDM.ensure ( root != null ) ;
                                                    
                                                   // create object
                                                   neighborCall = new NeighborCallAnnotation ( ) ;
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("caller", caller);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("callee", callee);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("fieldIdentifier", id1);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("methodCallIdentifier", id2);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("attr", attr);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("caller", caller);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("root", root);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("id1", id1);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("callee", callee);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("id2", id2);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference16 is really bound
                                                   JavaSDM.ensure ( reference16 != null ) ;
                                                    
                                                   // check object neighborCall is really bound
                                                   JavaSDM.ensure ( neighborCall != null ) ;
                                                    
                                                   // create link
                                                   neighborCall.addToAntecedentAnnos (reference16);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (neighborCall) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object neighborCall is really bound
            JavaSDM.ensure ( neighborCall != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("calleeClass", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("methodCallIdentifier", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.upb.javaast.methodast.IdentifierNode ) ;
             
            // explicit type cast
            id2 = (de.upb.javaast.methodast.IdentifierNode) fujaba__tmpTypeCastObject ;
             
            // bind methodCallNode21: MethodCallNode
            fujaba__TmpObject = id2.getPrimaryExpression () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
            methodCallNode21 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
             
            // bind primaryExpressionNode20: PrimaryExpressionNode
            primaryExpressionNode20 = methodCallNode21.getPrevPrimaryExpression () ;
            JavaSDM.ensure ( primaryExpressionNode20 != null ) ;
             
            // check isomorphic binding
            JavaSDM.ensure ( !(methodCallNode21.equals (primaryExpressionNode20)) ) ;
             
            // bind id1: IdentifierNode
            id1 = primaryExpressionNode20.getIdentifier () ;
            JavaSDM.ensure ( id1 != null ) ;
             
            // check isomorphic binding
            JavaSDM.ensure ( !(id2.equals (id1)) ) ;
             
            // Path search between PrimaryExpressionNode and ASTRootNode
            // Bind root : ASTRootNode
            fujaba__IterPrimaryExpressionNode20ToRoot = new ASTPathVisitorBottomUp (primaryExpressionNode20, ASTRootNode.class ) ;
            while ( fujaba__IterPrimaryExpressionNode20ToRoot.hasNext () )
            {
               try
               {
                  root = (de.uni_paderborn.fujaba.uml.ASTRootNode) fujaba__IterPrimaryExpressionNode20ToRoot.next () ;
                   
                  // bind caller: UMLMethod
                  caller = root.getMethod () ;
                  JavaSDM.ensure ( caller != null ) ;
                   
                  // bind callerClass: UMLClass
                  callerClass = caller.getParent () ;
                  JavaSDM.ensure ( callerClass != null ) ;
                   
                  // bind attr: UMLAttr
                  fujaba__IterCallerClassAttrsAttr = callerClass.iteratorOfAttrs () ;
                  while ( fujaba__IterCallerClassAttrsAttr.hasNext () )
                  {
                     try
                     {
                        attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsAttr.next () ;
                         
                        // bind reference19: ReferenceAnnotation
                        fujaba__IterAttrAnnotationsReference19 = attr.iteratorOfAnnotations () ;
                        while ( fujaba__IterAttrAnnotationsReference19.hasNext () )
                        {
                           try
                           {
                              fujaba__TmpObject = fujaba__IterAttrAnnotationsReference19.next () ;
                              JavaSDM.ensure ( fujaba__TmpObject instanceof ReferenceAnnotation ) ;
                              reference19 = (ReferenceAnnotation) fujaba__TmpObject ;
                               
                              // check Reverse-Qualified-Link 'elements' between reference19 and attr
                              JavaSDM.ensure ( reference19.hasInElements ("field", attr) ) ;
                               
                              // bind calleeClass: UMLClass
                              fujaba__IterReference19ElementsCalleeClass = reference19.iteratorOfElements ("references") ;
                              while ( fujaba__IterReference19ElementsCalleeClass.hasNext () )
                              {
                                 try
                                 {
                                    fujaba__TmpObject = fujaba__IterReference19ElementsCalleeClass.next () ;
                                    JavaSDM.ensure ( fujaba__TmpObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
                                    calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__TmpObject ;
                                     
                                    // check isomorphic binding
                                    JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                     
                                    // bind callee: UMLMethod
                                    fujaba__IterCalleeClassMethodsCallee = calleeClass.iteratorOfMethods () ;
                                    while ( fujaba__IterCalleeClassMethodsCallee.hasNext () )
                                    {
                                       try
                                       {
                                          callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterCalleeClassMethodsCallee.next () ;
                                           
                                          // check isomorphic binding
                                          JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id1.getName().equals(attr.getName()) ) ;
                                           
                                          // constraint
                                          JavaSDM.ensure ( id2.getName().equals(callee.getName()) ) ;
                                           
                                          {
                                             //  for each flow
                                             try
                                             {
                                                fujaba__Success = false ;
                                                 
                                                // check object callerClass is really bound
                                                JavaSDM.ensure ( callerClass != null ) ;
                                                 
                                                // check object caller is really bound
                                                JavaSDM.ensure ( caller != null ) ;
                                                 
                                                // check object callee is really bound
                                                JavaSDM.ensure ( callee != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                 
                                                // check object calleeClass is really bound
                                                JavaSDM.ensure ( calleeClass != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                 
                                                // check object id1 is really bound
                                                JavaSDM.ensure ( id1 != null ) ;
                                                 
                                                // check object id2 is really bound
                                                JavaSDM.ensure ( id2 != null ) ;
                                                 
                                                // check isomorphic binding
                                                JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                                 
                                                // bind neighborCall: NeighborCallAnnotation
                                                fujaba__IterCallerAnnotationsNeighborCall = caller.iteratorOfAnnotations () ;
                                                while ( !(fujaba__Success) && fujaba__IterCallerAnnotationsNeighborCall.hasNext () )
                                                {
                                                   try
                                                   {
                                                      fujaba__TmpObject = fujaba__IterCallerAnnotationsNeighborCall.next () ;
                                                      JavaSDM.ensure ( fujaba__TmpObject instanceof NeighborCallAnnotation ) ;
                                                      neighborCall = (NeighborCallAnnotation) fujaba__TmpObject ;
                                                       
                                                      // check Reverse-Qualified-Link 'elements' between neighborCall and caller
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("caller", caller) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and callerClass
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("callerClass", callerClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and callee
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("callee", callee) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and calleeClass
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("calleeClass", calleeClass) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and id1
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("fieldIdentifier", id1) ) ;
                                                       
                                                      // check To-Many-Link 'elements' between neighborCall and id2
                                                      JavaSDM.ensure ( neighborCall.hasInElements ("methodCallIdentifier", id2) ) ;
                                                       
                                                      fujaba__Success = true ;
                                                   }
                                                   catch ( JavaSDMException fujaba__InternalException )
                                                   {
                                                   }
                                                }
                                             }
                                             catch ( JavaSDMException fujaba__InternalException )
                                             {
                                                fujaba__Success = false ;
                                             }
                                              
                                             if ( !(fujaba__Success) )
                                             {
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object callerClass is really bound
                                                   JavaSDM.ensure ( callerClass != null ) ;
                                                    
                                                   // check object caller is really bound
                                                   JavaSDM.ensure ( caller != null ) ;
                                                    
                                                   // check object callee is really bound
                                                   JavaSDM.ensure ( callee != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(caller.equals (callee)) ) ;
                                                    
                                                   // check object calleeClass is really bound
                                                   JavaSDM.ensure ( calleeClass != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(callerClass.equals (calleeClass)) ) ;
                                                    
                                                   // check object id1 is really bound
                                                   JavaSDM.ensure ( id1 != null ) ;
                                                    
                                                   // check object id2 is really bound
                                                   JavaSDM.ensure ( id2 != null ) ;
                                                    
                                                   // check isomorphic binding
                                                   JavaSDM.ensure ( !(id1.equals (id2)) ) ;
                                                    
                                                   // check object attr is really bound
                                                   JavaSDM.ensure ( attr != null ) ;
                                                    
                                                   // check object root is really bound
                                                   JavaSDM.ensure ( root != null ) ;
                                                    
                                                   // create object
                                                   neighborCall = new NeighborCallAnnotation ( ) ;
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("caller", caller);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("callee", callee);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("fieldIdentifier", id1);
                                                    
                                                   // create link
                                                   neighborCall.addToElements ("methodCallIdentifier", id2);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("callerClass", callerClass);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("attr", attr);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("caller", caller);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("root", root);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("id1", id1);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("callee", callee);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("calleeClass", calleeClass);
                                                    
                                                   // create link
                                                   neighborCall.addToBoundObjects ("id2", id2);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                try
                                                {
                                                   fujaba__Success = false ;
                                                    
                                                   // check object reference19 is really bound
                                                   JavaSDM.ensure ( reference19 != null ) ;
                                                    
                                                   // check object neighborCall is really bound
                                                   JavaSDM.ensure ( neighborCall != null ) ;
                                                    
                                                   // create link
                                                   neighborCall.addToAntecedentAnnos (reference19);
                                                    
                                                   fujaba__Success = true ;
                                                }
                                                catch ( JavaSDMException fujaba__InternalException )
                                                {
                                                   fujaba__Success = false ;
                                                }
                                                 
                                                return (neighborCall) ;
                                             }
                                          } //  end for each flow
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                 }
                              }
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object neighborCall is really bound
            JavaSDM.ensure ( neighborCall != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("methodCallIdentifier", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (neighborCall) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("callerClass", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("caller", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("callee", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLClass )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("calleeClass", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof IdentifierNode )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("fieldIdentifier", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof IdentifierNode )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("methodCallIdentifier", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof ReferenceAnnotation )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("trigger", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      boolean fujaba__Success = false ;
      ASTPathVisitorBottomUp fujaba__IterPrimaryExpressionNode22ToRoot = null ;
      ASTPathVisitorBottomUp fujaba__IterPrimaryExpressionNode24ToRoot = null ;
      de.uni_paderborn.fujaba.uml.ASTRootNode root = null ;
      Iterator fujaba__IterCallerClassAttrsAttr = null ;
      de.upb.javaast.methodast.IdentifierNode id1 = null ;
      de.upb.javaast.methodast.IdentifierNode id2 = null ;
      de.upb.javaast.methodast.MethodCallNode methodCallNode23 = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode22 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode24 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr attr = null ;
      de.uni_paderborn.fujaba.uml.UMLClass calleeClass = null ;
      de.uni_paderborn.fujaba.uml.UMLClass callerClass = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod callee = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod caller = null ;
       
      TreeSet set = new TreeSet ();
      if ( annotation.equals ("Reference") )
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            callerClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // bind attr: UMLAttr
            fujaba__IterCallerClassAttrsAttr = callerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCallerClassAttrsAttr.hasNext () )
            {
               try
               {
                  attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsAttr.next () ;
                   
                  {
                     //  for each flow
                     set.add (attr);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            caller = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind callerClass: UMLClass
            callerClass = caller.getParent () ;
            JavaSDM.ensure ( callerClass != null ) ;
             
            // bind attr: UMLAttr
            fujaba__IterCallerClassAttrsAttr = callerClass.iteratorOfAttrs () ;
            while ( fujaba__IterCallerClassAttrsAttr.hasNext () )
            {
               try
               {
                  attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsAttr.next () ;
                   
                  {
                     //  for each flow
                     set.add (attr);
                  } //  end for each flow
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            callee = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind calleeClass: UMLClass
            calleeClass = callee.getParent () ;
            JavaSDM.ensure ( calleeClass != null ) ;
             
            {
               //  for each flow
               set.add (calleeClass);
            } //  end for each flow
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLClass ) ;
             
            // explicit type cast
            calleeClass = (de.uni_paderborn.fujaba.uml.UMLClass) fujaba__tmpTypeCastObject ;
             
            // collabStatBegin 1 is empty !
            set.add (calleeClass);
             
            // collabStatEnd
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.upb.javaast.methodast.IdentifierNode ) ;
             
            // explicit type cast
            id1 = (de.upb.javaast.methodast.IdentifierNode) fujaba__tmpTypeCastObject ;
             
            // bind primaryExpressionNode22: PrimaryExpressionNode
            primaryExpressionNode22 = id1.getPrimaryExpression () ;
            JavaSDM.ensure ( primaryExpressionNode22 != null ) ;
             
            // Path search between PrimaryExpressionNode and ASTRootNode
            // Bind root : ASTRootNode
            fujaba__IterPrimaryExpressionNode22ToRoot = new ASTPathVisitorBottomUp (primaryExpressionNode22, ASTRootNode.class ) ;
            while ( fujaba__IterPrimaryExpressionNode22ToRoot.hasNext () )
            {
               try
               {
                  root = (de.uni_paderborn.fujaba.uml.ASTRootNode) fujaba__IterPrimaryExpressionNode22ToRoot.next () ;
                   
                  // bind caller: UMLMethod
                  caller = root.getMethod () ;
                  JavaSDM.ensure ( caller != null ) ;
                   
                  // bind callerClass: UMLClass
                  callerClass = caller.getParent () ;
                  JavaSDM.ensure ( callerClass != null ) ;
                   
                  // bind attr: UMLAttr
                  fujaba__IterCallerClassAttrsAttr = callerClass.iteratorOfAttrs () ;
                  while ( fujaba__IterCallerClassAttrsAttr.hasNext () )
                  {
                     try
                     {
                        attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsAttr.next () ;
                         
                        {
                           //  for each flow
                           set.add (attr);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.upb.javaast.methodast.IdentifierNode ) ;
             
            // explicit type cast
            id2 = (de.upb.javaast.methodast.IdentifierNode) fujaba__tmpTypeCastObject ;
             
            // bind methodCallNode23: MethodCallNode
            fujaba__TmpObject = id2.getPrimaryExpression () ;
            JavaSDM.ensure ( (fujaba__TmpObject != null) && fujaba__TmpObject instanceof de.upb.javaast.methodast.MethodCallNode ) ;
            methodCallNode23 = (de.upb.javaast.methodast.MethodCallNode) fujaba__TmpObject ;
             
            // bind primaryExpressionNode24: PrimaryExpressionNode
            primaryExpressionNode24 = methodCallNode23.getPrevPrimaryExpression () ;
            JavaSDM.ensure ( primaryExpressionNode24 != null ) ;
             
            // check isomorphic binding
            JavaSDM.ensure ( !(methodCallNode23.equals (primaryExpressionNode24)) ) ;
             
            // Path search between PrimaryExpressionNode and ASTRootNode
            // Bind root : ASTRootNode
            fujaba__IterPrimaryExpressionNode24ToRoot = new ASTPathVisitorBottomUp (primaryExpressionNode24, ASTRootNode.class ) ;
            while ( fujaba__IterPrimaryExpressionNode24ToRoot.hasNext () )
            {
               try
               {
                  root = (de.uni_paderborn.fujaba.uml.ASTRootNode) fujaba__IterPrimaryExpressionNode24ToRoot.next () ;
                   
                  // bind caller: UMLMethod
                  caller = root.getMethod () ;
                  JavaSDM.ensure ( caller != null ) ;
                   
                  // bind callerClass: UMLClass
                  callerClass = caller.getParent () ;
                  JavaSDM.ensure ( callerClass != null ) ;
                   
                  // bind attr: UMLAttr
                  fujaba__IterCallerClassAttrsAttr = callerClass.iteratorOfAttrs () ;
                  while ( fujaba__IterCallerClassAttrsAttr.hasNext () )
                  {
                     try
                     {
                        attr = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterCallerClassAttrsAttr.next () ;
                         
                        {
                           //  for each flow
                           set.add (attr);
                        } //  end for each flow
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
      }
      return (set.iterator ()) ;
   }


}
