package de.upb.inferenceengine.engines;

import de.upb.tools.fca.FEmptyIterator;
import de.upb.inferenceengine.visitors.*;
import de.uni_paderborn.fujaba.asg.ASGElement;
import de.upb.tools.sdm.*;
import java.util.*;
import de.upb.tools.fca.*;
import de.uni_paderborn.fujaba.uml.UMLMethod;
import de.uni_paderborn.fujaba.uml.UMLAttr;
import de.uni_paderborn.fujaba.uml.UMLType;
import de.upb.javaast.methodast.ReturnNode;
import de.uni_paderborn.fujaba.uml.ASTRootNode;
import de.upb.javaast.methodast.PrimaryExpressionNode;
import de.upb.javaast.methodast.IdentifierNode;
import de.uni_paderborn.fujaba.uml.UMLClass;

public class ReadOperationEngine
extends GFRNEngine
{
   private  ReadOperationEngine()
   {
   }

   private static ReadOperationEngine theReadOperationEngine;

   public static ReadOperationEngine get()
   {
      if (theReadOperationEngine == null)
      {
         theReadOperationEngine = new ReadOperationEngine ();
      }
      return theReadOperationEngine;
   }

   public GFRNAnnotation annotate(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
      ASTPathVisitor fujaba__IterReturnNode2ToPrimaryExpressionNode3 = null ;
      ASTPathVisitor fujaba__IterReturnNode6ToPrimaryExpressionNode7 = null ;
      ASTPathVisitor fujaba__IterRootToReturnNode2 = null ;
      ASTPathVisitor fujaba__IterRootToReturnNode6 = null ;
      de.uni_paderborn.fujaba.uml.ASTRootNode root = null ;
      Iterator fujaba__IterAttribAnnotationsReadOperation = null ;
      Iterator fujaba__IterUMLType1RevAttrTypeAttrib = null ;
      Iterator fujaba__IterUMLType5RevResultTypeReadMethod = null ;
      de.upb.javaast.methodast.IdentifierNode id = null ;
      Object fujaba__TmpObject = null ;
      Object fujaba__tmpTypeCastObject = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode3 = null ;
      de.upb.javaast.methodast.PrimaryExpressionNode primaryExpressionNode7 = null ;
      ReadOperationAnnotation readOperation = null ;
      de.upb.javaast.methodast.ReturnNode returnNode2 = null ;
      de.upb.javaast.methodast.ReturnNode returnNode6 = null ;
      de.uni_paderborn.fujaba.uml.UMLAttr attrib = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass4 = null ;
      de.uni_paderborn.fujaba.uml.UMLClass uMLClass8 = null ;
      de.uni_paderborn.fujaba.uml.UMLMethod readMethod = null ;
      de.uni_paderborn.fujaba.uml.UMLType uMLType1 = null ;
      de.uni_paderborn.fujaba.uml.UMLType uMLType5 = null ;
       
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLMethod ) ;
             
            // explicit type cast
            readMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__tmpTypeCastObject ;
             
            // bind root: ASTRootNode
            root = readMethod.getASTRootNode () ;
            JavaSDM.ensure ( root != null ) ;
             
            // bind uMLType1: UMLType
            uMLType1 = readMethod.getResultType () ;
            JavaSDM.ensure ( uMLType1 != null ) ;
             
            // bind uMLClass4: UMLClass
            uMLClass4 = readMethod.getParent () ;
            JavaSDM.ensure ( uMLClass4 != null ) ;
             
            // check isomorphic binding
            JavaSDM.ensure ( !(uMLType1.equals (uMLClass4)) ) ;
             
            // bind attrib: UMLAttr
            fujaba__IterUMLType1RevAttrTypeAttrib = uMLType1.iteratorOfRevAttrType () ;
            while ( fujaba__IterUMLType1RevAttrTypeAttrib.hasNext () )
            {
               try
               {
                  attrib = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__IterUMLType1RevAttrTypeAttrib.next () ;
                   
                  // check To-One-Link 'parent' between attrib and uMLClass4
                  JavaSDM.ensure ( (attrib.getParent () != null) && attrib.getParent ().equals (uMLClass4) ) ;
                   
                  // Path search between ASTRootNode and ReturnNode
                  // Bind returnNode2 : ReturnNode
                  fujaba__IterRootToReturnNode2 = new ASTPathVisitor (root, ReturnNode.class ) ;
                  while ( fujaba__IterRootToReturnNode2.hasNext () )
                  {
                     try
                     {
                        returnNode2 = (de.upb.javaast.methodast.ReturnNode) fujaba__IterRootToReturnNode2.next () ;
                         
                        // Path search between ReturnNode and PrimaryExpressionNode
                        // Bind primaryExpressionNode3 : PrimaryExpressionNode
                        fujaba__IterReturnNode2ToPrimaryExpressionNode3 = new ASTPathVisitor (returnNode2, PrimaryExpressionNode.class ) ;
                        while ( fujaba__IterReturnNode2ToPrimaryExpressionNode3.hasNext () )
                        {
                           try
                           {
                              primaryExpressionNode3 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterReturnNode2ToPrimaryExpressionNode3.next () ;
                               
                              // bind id: IdentifierNode
                              id = primaryExpressionNode3.getIdentifier () ;
                              JavaSDM.ensure ( id != null ) ;
                               
                              // constraint
                              JavaSDM.ensure ( id.getName().equals(attrib.getName()) ) ;
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object readMethod is really bound
                                    JavaSDM.ensure ( readMethod != null ) ;
                                     
                                    // check object attrib is really bound
                                    JavaSDM.ensure ( attrib != null ) ;
                                     
                                    // bind readOperation: ReadOperationAnnotation
                                    fujaba__IterAttribAnnotationsReadOperation = attrib.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterAttribAnnotationsReadOperation.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAttribAnnotationsReadOperation.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof ReadOperationAnnotation ) ;
                                          readOperation = (ReadOperationAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between readOperation and attrib
                                          JavaSDM.ensure ( readOperation.hasInElements ("field", attrib) ) ;
                                           
                                          // check To-Many-Link 'elements' between readOperation and readMethod
                                          JavaSDM.ensure ( readOperation.hasInElements ("method", readMethod) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object readMethod is really bound
                                       JavaSDM.ensure ( readMethod != null ) ;
                                        
                                       // check object attrib is really bound
                                       JavaSDM.ensure ( attrib != null ) ;
                                        
                                       // check object root is really bound
                                       JavaSDM.ensure ( root != null ) ;
                                        
                                       // check object id is really bound
                                       JavaSDM.ensure ( id != null ) ;
                                        
                                       // create object
                                       readOperation = new ReadOperationAnnotation ( ) ;
                                        
                                       // create link
                                       readOperation.addToElements ("method", readMethod);
                                        
                                       // create link
                                       readOperation.addToElements ("field", attrib);
                                        
                                       // create link
                                       readOperation.addToBoundObjects ("readMethod", readMethod);
                                        
                                       // create link
                                       readOperation.addToBoundObjects ("attrib", attrib);
                                        
                                       // create link
                                       readOperation.addToBoundObjects ("root", root);
                                        
                                       // create link
                                       readOperation.addToBoundObjects ("id", id);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (readOperation) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object readOperation is really bound
            JavaSDM.ensure ( readOperation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("method", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      try
      {
         fujaba__Success = false ;
          
         // check object asgElement is really bound
         JavaSDM.ensure ( asgElement != null ) ;
          
         // check To-Many-Link 'failedApplications' between this and asgElement
         JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
          
         fujaba__Success = true ;
      }
      catch ( JavaSDMException fujaba__InternalException )
      {
         fujaba__Success = false ;
      }
       
      if ( fujaba__Success )
      {
      }
      else
      {
         try
         {
            fujaba__Success = false ;
             
            fujaba__tmpTypeCastObject = asgElement ;
            // ensure correct type and really bound
            JavaSDM.ensure ( fujaba__tmpTypeCastObject instanceof de.uni_paderborn.fujaba.uml.UMLAttr ) ;
             
            // explicit type cast
            attrib = (de.uni_paderborn.fujaba.uml.UMLAttr) fujaba__tmpTypeCastObject ;
             
            // bind uMLType5: UMLType
            uMLType5 = attrib.getAttrType () ;
            JavaSDM.ensure ( uMLType5 != null ) ;
             
            // bind uMLClass8: UMLClass
            uMLClass8 = attrib.getParent () ;
            JavaSDM.ensure ( uMLClass8 != null ) ;
             
            // check isomorphic binding
            JavaSDM.ensure ( !(uMLType5.equals (uMLClass8)) ) ;
             
            // bind readMethod: UMLMethod
            fujaba__IterUMLType5RevResultTypeReadMethod = uMLType5.iteratorOfRevResultType () ;
            while ( fujaba__IterUMLType5RevResultTypeReadMethod.hasNext () )
            {
               try
               {
                  readMethod = (de.uni_paderborn.fujaba.uml.UMLMethod) fujaba__IterUMLType5RevResultTypeReadMethod.next () ;
                   
                  // check To-One-Link 'parent' between readMethod and uMLClass8
                  JavaSDM.ensure ( (readMethod.getParent () != null) && readMethod.getParent ().equals (uMLClass8) ) ;
                   
                  // bind root: ASTRootNode
                  root = readMethod.getASTRootNode () ;
                  JavaSDM.ensure ( root != null ) ;
                   
                  // Path search between ASTRootNode and ReturnNode
                  // Bind returnNode6 : ReturnNode
                  fujaba__IterRootToReturnNode6 = new ASTPathVisitor (root, ReturnNode.class ) ;
                  while ( fujaba__IterRootToReturnNode6.hasNext () )
                  {
                     try
                     {
                        returnNode6 = (de.upb.javaast.methodast.ReturnNode) fujaba__IterRootToReturnNode6.next () ;
                         
                        // Path search between ReturnNode and PrimaryExpressionNode
                        // Bind primaryExpressionNode7 : PrimaryExpressionNode
                        fujaba__IterReturnNode6ToPrimaryExpressionNode7 = new ASTPathVisitor (returnNode6, PrimaryExpressionNode.class ) ;
                        while ( fujaba__IterReturnNode6ToPrimaryExpressionNode7.hasNext () )
                        {
                           try
                           {
                              primaryExpressionNode7 = (de.upb.javaast.methodast.PrimaryExpressionNode) fujaba__IterReturnNode6ToPrimaryExpressionNode7.next () ;
                               
                              // bind id: IdentifierNode
                              id = primaryExpressionNode7.getIdentifier () ;
                              JavaSDM.ensure ( id != null ) ;
                               
                              // constraint
                              JavaSDM.ensure ( id.getName().equals(attrib.getName()) ) ;
                               
                              {
                                 //  for each flow
                                 try
                                 {
                                    fujaba__Success = false ;
                                     
                                    // check object readMethod is really bound
                                    JavaSDM.ensure ( readMethod != null ) ;
                                     
                                    // check object attrib is really bound
                                    JavaSDM.ensure ( attrib != null ) ;
                                     
                                    // bind readOperation: ReadOperationAnnotation
                                    fujaba__IterAttribAnnotationsReadOperation = attrib.iteratorOfAnnotations () ;
                                    while ( !(fujaba__Success) && fujaba__IterAttribAnnotationsReadOperation.hasNext () )
                                    {
                                       try
                                       {
                                          fujaba__TmpObject = fujaba__IterAttribAnnotationsReadOperation.next () ;
                                          JavaSDM.ensure ( fujaba__TmpObject instanceof ReadOperationAnnotation ) ;
                                          readOperation = (ReadOperationAnnotation) fujaba__TmpObject ;
                                           
                                          // check Reverse-Qualified-Link 'elements' between readOperation and attrib
                                          JavaSDM.ensure ( readOperation.hasInElements ("field", attrib) ) ;
                                           
                                          // check To-Many-Link 'elements' between readOperation and readMethod
                                          JavaSDM.ensure ( readOperation.hasInElements ("method", readMethod) ) ;
                                           
                                          fujaba__Success = true ;
                                       }
                                       catch ( JavaSDMException fujaba__InternalException )
                                       {
                                       }
                                    }
                                 }
                                 catch ( JavaSDMException fujaba__InternalException )
                                 {
                                    fujaba__Success = false ;
                                 }
                                  
                                 if ( !(fujaba__Success) )
                                 {
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       // check object readMethod is really bound
                                       JavaSDM.ensure ( readMethod != null ) ;
                                        
                                       // check object attrib is really bound
                                       JavaSDM.ensure ( attrib != null ) ;
                                        
                                       // check object root is really bound
                                       JavaSDM.ensure ( root != null ) ;
                                        
                                       // check object id is really bound
                                       JavaSDM.ensure ( id != null ) ;
                                        
                                       // create object
                                       readOperation = new ReadOperationAnnotation ( ) ;
                                        
                                       // create link
                                       readOperation.addToElements ("method", readMethod);
                                        
                                       // create link
                                       readOperation.addToElements ("field", attrib);
                                        
                                       // create link
                                       readOperation.addToBoundObjects ("readMethod", readMethod);
                                        
                                       // create link
                                       readOperation.addToBoundObjects ("attrib", attrib);
                                        
                                       // create link
                                       readOperation.addToBoundObjects ("root", root);
                                        
                                       // create link
                                       readOperation.addToBoundObjects ("id", id);
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    try
                                    {
                                       fujaba__Success = false ;
                                        
                                       fujaba__Success = true ;
                                    }
                                    catch ( JavaSDMException fujaba__InternalException )
                                    {
                                       fujaba__Success = false ;
                                    }
                                     
                                    return (readOperation) ;
                                 }
                              } //  end for each flow
                           }
                           catch ( JavaSDMException fujaba__InternalException )
                           {
                           }
                        }
                     }
                     catch ( JavaSDMException fujaba__InternalException )
                     {
                     }
                  }
               }
               catch ( JavaSDMException fujaba__InternalException )
               {
               }
            }
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         try
         {
            fujaba__Success = false ;
             
            // check object readOperation is really bound
            JavaSDM.ensure ( readOperation != null ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            try
            {
               fujaba__Success = false ;
                
               // check object asgElement is really bound
               JavaSDM.ensure ( asgElement != null ) ;
                
               // create link
               this.addToFailedApplications ("field", asgElement);
                
               fujaba__Success = true ;
            }
            catch ( JavaSDMException fujaba__InternalException )
            {
               fujaba__Success = false ;
            }
             
         }
      }
      return (readOperation) ;
   }


   public boolean applicationAlreadyFailed(ASGElement asgElement)
   {
      boolean fujaba__Success = false ;
       
      boolean result = true;
      if ( asgElement instanceof UMLMethod )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("method", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      if ( asgElement instanceof UMLAttr )
      {
         try
         {
            fujaba__Success = false ;
             
            // check object asgElement is really bound
            JavaSDM.ensure ( asgElement != null ) ;
             
            // check To-Many-Link 'failedApplications' between this and asgElement
            JavaSDM.ensure ( this.hasInFailedApplications ("field", asgElement) ) ;
             
            fujaba__Success = true ;
         }
         catch ( JavaSDMException fujaba__InternalException )
         {
            fujaba__Success = false ;
         }
          
         if ( fujaba__Success )
         {
         }
         else
         {
            result = false;
         }
      }
      return (result) ;
   }


   public Iterator getTrigger(ASGElement asgElement, String annotation)
   {
      return (FEmptyIterator.get()) ;
   }


}
